/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.NumberTextBox");

dojo.require("dojox.data.dom");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.util.PermissionControlUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog");

(function(){
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var util = com.ibm.team.workitem.web.client.util;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var permissonUtil = com.ibm.rqm.process.web.ui.internal.util.PermissionControlUtil;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	
	var COMMAND_CREATE = "create"; //$NON-NLS$
    var COMMAND_UPDATE = "update"; //$NON-NLS$
    var COMMAND_REMOVE = "remove"; //$NON-NLS$	
    
	//value=0: All; value=1: Pending; value=2: Approved; value=3: Rejected
	var VIEW_ALL = 0;
	var VIEW_PENDING = 1;
	var VIEW_APPROVED = 2;
	var VIEW_REJECTED = 3;
	
    dojo.declare("ApprovalTable.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        parentView: null,
        
        constructor: function(testView){
            this.parentView = testView;
        },
        
        rowCheckStateChanged: function(tableViewer, rowObject, state){
			var selectionCount = tableViewer.getCheckedRows().length;
        	if (this.parentView.deleteActionNode)
            	this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
        },
        
        tableContentSelectionChanged: function(tableViewer, contentSelectionValue){
            var content = this.parentView.changeContent(contentSelectionValue);
            tableViewer.setContent(content);
            tableViewer.show();
        },

        tableContentActionInvoked: function(tableViewer, actionId, callbackData){
            switch (actionId) {
                case "add":
                    this.parentView._handleAddNewClick();
                    break;
                case "remove":
                    this.parentView._handleDeleteClick();
                    break;
                default:
                    break;
            }
        }
    });
    
    dojo.declare("ApprovalTable.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
        
        constructor: function(viewer, parent){
            this.tableViewer = viewer;
            this.parent = parent;
        },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
            if (this.parent.parentSection) {
                this.parent.parentSection.setDirty();
            }
            switch (columnIndex) {
                case 2:
					if (!rowObject.origStatus) rowObject.origStatus = rowObject.status; //cache original status
					rowObject.status = newValue;
                    break;
                case 3:
                    rowObject.comment = newValue;
                    break;
                case 0:
                    rowObject.approvalType = newValue;
                    break;
                case 1:
                    rowObject.ownerItem = newValue;
                    break;
                case 4:
                    rowObject.newDueDate = newValue != null ? newValue : COMMAND_REMOVE;
                    break;
                default:
                    break;
            }
        },
        
        cellActionInvoked: function(rowObject, columnIndex){
        }
    });
    
    dojo.declare("ApprovalTable.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        
        constructor: function(args) {
	        dojo.mixin(this, args);
	        if (!this.ownerChoices || !dojo.isArray(this.ownerChoices)) {
	            throw new Error("Parameter 'ownerChoices' is REQUIRED!");
	        }
		},
		
		getNumColumns: function(content){
            return 5;
        },

        getColumnHeading: function(content, index){
            var headings = [
                Constants.APPROVAL_TITLE_APPROVAL_TABLE, 
				Constants.APPROVAL_NAME_APPROVAL_TABLE, 
				Constants.APPROVAL_STATUS_APPROVAL_TABLE, 
				Constants.APPROVAL_COMMENTS_APPROVAL_TABLE, 
				Constants.getMessage("labelDueDate")
			];
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return (atColumnIndex == 0 ||atColumnIndex == 2);
        },
        
        getColumnWidth: function(content, atColumnIndex){
            var width = 16;
            switch (atColumnIndex) {
                case 0:
                    width = 15;
                    break;
                case 1:
                    width = 20;
                    break;
                case 2:
                    width = 15;
                    break;
                case 3:
                    width = 40;
                    break;
                case 4:
                    width = 10;
                    break;
            }
            return width;
        },
		
        getIsCellEditable: function(rowData, atColumnIndex){
            var isEditable = false;
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            var canCreate = !permission || permission[PermissionsClient.ACTION_CREATE];
			var isReviewer = permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER);
			var isPending = !rowData.status || rowData.status == Constants.TYPE_PENDING;
			var wasPending = rowData.origStatus === Constants.TYPE_PENDING;
            switch (atColumnIndex) {
                case 0:
                case 1:
                    isEditable = (this.tableEditable && canCreate && !isReviewer && isPending) ? true : false;
                    break;
                case 2:
                    isEditable = ((isReviewer && (isPending || wasPending)) || (canCreate && rowData.status == Constants.TYPE_REJECTED)) ? true : false;
                    break;
                case 3:
                    isEditable = (isReviewer && (isPending || wasPending)) ? true : false;
                    break;
                case 4:
                    isEditable = (this.tableEditable && canCreate);
                    break;
            }
            return isEditable;
        },
        
        getContentObjects: function(content){
            return content;
        },
        
        getRowDataId: function(rowData){
            return "_rowid_for_approval_" + rowData.id;
        },
        
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_ENUM;            
            switch (atColumnIndex) {
                case 3:
                    type = TableConstants.RENDER_TYPE_COMMENT;
                    break;
                case 4:
                    type = TableConstants.RENDER_TYPE_EDITABLE_DATE;
                    break;
            }
            return type;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.approvalType;
                    break;
                case 1:
                    val = (rowData.owner == null) ? null : rowData.owner.name;
                    break;
                case 2:
                    val = rowData.status;
                    break;
                case 3:
					if(this.getIsCellEditable(rowData,atColumnIndex))
						val = rowData.comment;
					else
                    	val = rowData.shortComment;
                    break;
                case 4:
                    val = rowData.date;
                    break;
            }
            return val;
        },
     
	    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = {};
			//Selection of role (Reviewer/Approver)
            if (atColumnIndex == 0) {
                val['select'] = rowData.approvalType;
                val['choices'] = [{
                    'text': Constants.APPROVAL_APPROVAL_APPROVAL_TABLE,
                    'value': Constants.TYPE_APPROVER
                }, {
                    'text': Constants.APPROVAL_REVIEWER_APPROVAL_TABLE,
                    'value': Constants.TYPE_REVIEWER
                }];
            }
			//Selection of ownership (Which user owns THIS approval record/row)
            if (atColumnIndex == 1) {
                val['select'] = rowData.ownerItem;//(typeof rowData.selection != "undefined") ? rowData.selection : null;
                val['choices'] = [];
				//Iterate over all the possible owners adding only those that are not archived OR match the current owner.
				var choices = this.ownerChoices || [];
				for (var i = 0; i < choices.length; i++) {
					var choice = choices[i];
					if (!choice.archived) {
						if (choice.value == rowData.ownerItem) {
							choice.disabled = true;
						}
						val['choices'].push(choice);
					}					
				}			
            }
			//Selection of action (Approve/Reject/Reopen)
            if (atColumnIndex == 2) {
                val['select'] = (rowData.status == null) ? rowData.status : rowData.status;
                val['choices'] = [{
                    'text': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                    'value': Constants.TYPE_PENDING
                }, {
                    'text': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                    'value': Constants.TYPE_APPROVED
                }, {
                    'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                    'value': Constants.TYPE_REJECTED
                }];
				if (rowData.approvalType == Constants.TYPE_REVIEWER) 
                	val['choices'] = [{
                		'text': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                    	'value': Constants.TYPE_PENDING
                	}, {
                    	'text': Constants.APPROVAL_REVIEWED_APPROVAL_TABLE,
                    	'value': Constants.TYPE_APPROVED
                    }];
				var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            	if (!permission || permission[PermissionsClient.ACTION_CREATE])	{
                    if (rowData.status == Constants.TYPE_REJECTED) 
                        val['choices'] = [{
                            'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                            'value': Constants.TYPE_REJECTED
                        }, {
                            'text': Constants.APPROVAL_REOPEN_APPROVAL_TABLE,
                            'value': Constants.TYPE_PENDING
                        }];
                }
                else 
                    if (permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER)) {
                        if (rowData.approvalType == Constants.TYPE_APPROVER) 
                            val['choices'] = [{
                                'text': ' ',
                                'value': Constants.TYPE_PENDING
                            }, {
                                'text': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                                'value': Constants.TYPE_APPROVED
                            }, {
                                'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                                'value': Constants.TYPE_REJECTED
                            }];
                    }
            }
            if (atColumnIndex == 3) {
                val['tooltip'] = rowData.comment;
            }
            if (rowData.selected) {
                val['state'] = true;
            }
            return val;
        }
    });
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
        '</div>',
        widgetsInTemplate: true,
        printable: false,
		
        constructor: function(args){
            this._approvals = null;
            this._itemId = null;
            this.role = []; //0: manager; 1: approver/reviewer; 2: others
            this.content = null;
            this._ownerChoices = null;
            this.deleted = null;
            this.updated = null;
            this.currentUser = null;
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
            this.deleted = new Array();
            this.updated = new Array();
            this.parentSection = args.parentSection ? args.parentSection : null;
			this.printable = args.printable ? args.printable : null;
            this._approvals = args.approvals;
            this._itemId = args.itemId;
            this._itemType = args.itemType;
            this._sectionContainer = args.sectionContainer;
            this._mainReview = args.mainReview;
            this._ownerChoices = args.ownerChoices;
            if (args.role == Constants.ROLE_OWNER) {
				this.role.push(args.role);
			}
            this.currentUser = args.currentUser;
            this._isEditable = args.isEditable;
//            this.projectAreaName = EditorUtil.getCurrentProjectArea().name;
            
	        //create the table viewer
	        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            //turn off all controls if in print mode 
	            showPagingControl: !this.printable,
				showPagingRangeControl: !this.printable,
	            showGroupFilterControls: !this.printable,
	            showPagingActionsControls: !this.printable,
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-PROC-APPROVAL-TABLEVIEWER"                         
	        });
		
            this.domNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
            
            this.content = this.createContent();
            var contentProvider = new ApprovalTable.TableProvider({
				ownerChoices: this._ownerChoices,
                tableEditable: this._isEditable
			});
            
            var views = [{
                'name': Constants.APPROVAL_ALL_APPROVAL_TABLE,
                'value': VIEW_ALL
            }, {
                'name': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                'value': VIEW_PENDING
            }, {
                'name': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                'value': VIEW_APPROVED
            }, {
                'name': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                'value': VIEW_REJECTED
            }];
            tableViewer.setTableContentSelectors(views);
            
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            // check permission for add reviewer
            if (this._isEditable && (!permission || permission[PermissionsClient.ACTION_CREATE])) {
           	    tableViewer.addAction("add", Constants.APPROVAL_ADD_AR_APPROVAL_TABLE, "_handleAddNewClick", "add-icon-image");
                this.deleteActionNode = tableViewer.addAction("remove", Constants.APPROVAL_REMOVE_AR_APPROVAL_TABLE, "_handleDeleteClick", "remove-enabled-icon-image");
				this.deleteActionNode.setDisabled(true);
            }
            tableViewer.setContent(this.content);
            tableViewer.setContentProvider(contentProvider);
            tableViewer.setTableListener(new ApprovalTable.TableListener(this));
            tableViewer.setCellModifier(new ApprovalTable.CellModifier(tableViewer, this));
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelFormalReview")));
            tableViewer.show();
        },
        
        
        createContent: function(){
            var rows = [];
			var approvals = this._approvals;
            var apprLen = approvals ? approvals.length : 0;
			var currUserItemId = this.currentUser.itemId;
            for (var i = 0; i < apprLen; i++) {
                var res = approvals[i];
                var tmpRole = [];
                if (permissonUtil.checkOperation(this.role, Constants.ROLE_OWNER)) 
                    tmpRole.push(Constants.ROLE_OWNER);
                if (res.owner.itemId == currUserItemId) {
                    this.role.push(Constants.ROLE_REVIEWER);
                    tmpRole.push(Constants.ROLE_REVIEWER);
                }
				var comment = (res.comments == null) ? "" : res.comments[res.comments.length - 1].content;
				comment = this.getSafeText(comment);
				var shortComment = this.getClippedComment(comment);
                var obj = {
                    approvalType: res.approvalType,
                    owner: res.owner,
                    status: res.status,
                    comment: comment,
                    date: (res.date == null) ? "" : res.date,
                    ownerItem: res.owner.itemId,
                    //type: 0, //type=0: existed; type=1: new;
					isNew: false,
                    role: tmpRole,//(this.role == 0)?this.role:tmpRole
                    id: res.id != null ? res.id : (new Date()).getTime(),
					internalUUID: res.internalApprovalUUID || "",
					shortComment: shortComment
                };
                rows.push(obj);
            }
            return rows;
        },
        
        //value=0: All; value=1: Pending; value=2: Approved; value=3: Rejected
        changeContent: function(value){
            var newContent = [];
			var content = this.content;
			var contentLen = content && content.length ? content.length : 0;
			
            // make sure the value is an int
            value = parseInt(value);
            
            switch (value) {
                case VIEW_ALL:
                    newContent = content;
                    break;
					
                case VIEW_PENDING:
					//return only the rows that are 'PENDING'
                    for (var i = 0; i < contentLen; i++) {
						var row = content[i];
                        if (!row.status || row.status == Constants.TYPE_PENDING) newContent.push(row);
                    }
                    break;
                case VIEW_APPROVED:
					//return only the rows that are 'APPROVED'
                    for (var i = 0; i < contentLen; i++) {
                        var row = content[i];
						if (row.status == Constants.TYPE_APPROVED) newContent.push(row);
                    }
                    break;
                case VIEW_REJECTED:
					//return only the rows that are 'REJECTED'
                    for (var i = 0; i < contentLen; i++) {
						var row = content[i];
                        if (row.status == Constants.TYPE_REJECTED) newContent.push(row);
                    }
                    break;
                default:
                    break;
            }
            return newContent;
        },
        
        _handleAddNewClick: function(){
            var selectedOwner = [];
            if (this.content && this.content.length > 0) {
                for (var i = 0; i < this.content.length; i++) {
                    selectedOwner.push({
                        'itemId': this.content[i].ownerItem
                    });
                }
            }
            var self = this;
            var params = {
                title: Constants.APPROVAL_ADD_USERS_APPROVAL_TABLE,
                parentElement: this.domNode,
                disableUsers: selectedOwner,
				ownerChoices: this._ownerChoices,
                parent: this
            };
            new com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog(params);
		},
        
        _handleDeleteClick: function(){
			this.parentSection.getParentEditor().clearStatus();
            var dels = this.tableViewer.getCheckedRows();
            if (dels && dels.length > 0) {
				for (var i = 0; i < dels.length; i++) {
                	if ((dels[i].status && (dels[i].status == Constants.TYPE_APPROVED || dels[i].status == Constants.TYPE_REJECTED))) {
                        var msg = Constants.getMessage("msgDelReviewItems");
		                var args = {
				            'message': msg
				        };
				        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
				        confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
				        confirmDialog.open();
						break;
                    }
                    else {
                        this.deleted.push(dels[i]);
                        this.tableViewer.deleteItem(dels[i]);
                    }
                }
                this.content = this.tableViewer.getContent();
                this.tableViewer.show();
                if (this.parentSection != null) {
                    this.parentSection.setDirty();
                }
            }
            else {
				this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, 
					Constants.APPROVAL_REMOVE_MORE_WARNING_APPROVAL_TABLE);
            }
        },
        
        changeRowEditable: function(isEditable) {
            if (isEditable) {
				var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
                var checkable = (!permission || permission[PermissionsClient.ACTION_CREATE]) ? true : false;
                this.tableViewer.setTableRowsCheckable(!this.printable, false);
            } else {
                this.tableViewer.setTableRowsCheckable(false, false);
            }
            // approval is always editable even the user only has viewer license
			// work item: 13788
			// comment out until back end support saving artifact when user only has viewer license
			//            this.tableViewer.setEditable(true);
            this.tableViewer.setEditable(isEditable);
            
            this.tableViewer.show();
        },
		
		_getUpdateCommands: function() {
			var commands = [];
            if (!this._validateUsers()) {
                return commands;
            }
			var editor = this.parentSection.getParentEditor();
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
			
			var rows = this.content && this.content.length > 0 ? this.content : [];
			//for each row, create the appropriate command to update the workitem on the server
            for (var i = 0; i < rows.length; i++) {
                var row = rows[i];
				var isOwner = permissonUtil.checkOperation(row.role, Constants.ROLE_OWNER);
				var isReviewer = permissonUtil.checkOperation(row.role, Constants.ROLE_REVIEWER);				
				if (row.isNew) {
					if (permission && permission[PermissionsClient.ACTION_CREATE]) {
						//user has the 'create' permission; add command
						var command = {
							cmd: COMMAND_CREATE,
							approvalObj: {
	                        	owner: row.ownerItem,
	                        	approvalType: row.approvalType
	                    	}
						}
						if (row.newDueDate != null) {
							command.approvalObj.dueDate = row.newDueDate.getTime();
						}						
	                    commands.push(command);
					}

                } else {
						//create the update command; populate it based on role
						var command = {
							cmd: COMMAND_UPDATE,
							approvalObj: {
								descriptorId: row.id,	
								internalUUID: row.internalUUID,
								approvalType: row.approvalType,
								owner: isOwner ? row.ownerItem : row.owner.itemId			
	                    	}
						}				
						if (row.newDueDate != null) {
							//new date provided; add to object for update
							command.approvalObj.dueDate = row.newDueDate instanceof Date ? row.newDueDate.getTime() : row.newDueDate;
						}						
						//only reviewers or the owner updating a rejected status can change the status / comment
						if (isReviewer || (isOwner && row.origStatus == Constants.TYPE_REJECTED) ) {		
	                        command.approvalObj.status = row.status;
							if (row.comment && row.comment != "") {
								//add the comment
								command.approvalObj.comment = this.restoreTags(row.comment);
							}						
						}
						commands.push(command);
				}
            }	
			
			//add delete commands
			var deleted = this.deleted && this.deleted.length > 0 ? this.deleted : [];
            for (var i = 0; i < deleted.length; i++) {
				if (!deleted[i].isNew) {
					var command = {
						cmd: COMMAND_REMOVE,
						approvalObj: {
							descriptorId: deleted[i].id
                    	}
					}
                	commands.push(command);
				}				
            }
			
			return commands;
		},
        
        validate: function(){
			//ensure any rejections contain a comment
            for (var i = 0; i < this.content.length; i++) {
                var obj = this.content[i];
                if (obj.status == Constants.TYPE_REJECTED && obj.comment == "") {
					return {
						msg: Constants.APPROVAL_REJECT_REASON_DUPLICATED_WARNING_APPROVAL_TABLE,
						value: false
					};
                }
            }
            return this._validateUsers();
        },
        
        _validateUsers: function() {
			//ensure there are no duplicated approvers/reviewers
            if (this.content && this.content.length > 0) {
                for (var i = 0; i < this.content.length; i++) {
                    var owner1 = this.content[i].ownerItem;
                    for (var j = i + 1; j < this.content.length; j++) {
                        var owner2 = this.content[j].ownerItem;
                        if (owner1 == owner2) {
							return {
								msg: Constants.APPROVAL_ADDING_DUPLICATED_WARNING_APPROVAL_TABLE,
								value: false
							};
                        }
                    }
                }
            }
            return {value: true};
        },
        
        _hasAddSaveButton: function(actions){
            if (actions && actions.length > 0) {
                for (var i = 0; i < actions.length; i++) {
                    if (actions[i].label == "Save") 
                        return true;
                }
            }
            return false;
        },
        
        _error: function(errorObj){
            alert(errorObj.message);
        },
		
		 getSafeText: function(rawText, editorPart){
            rawText = rawText.replace(/<synthetic>/g, "");
            rawText = rawText.replace(/<\/synthetic>/g, "");
            rawText = rawText.replace(/>/g, "&gt;");
            rawText = rawText.replace(/</g, "&lt;");
            rawText = rawText.replace(/(\n|\&#xA;)/g, "<br/>");
            rawText = rawText.replace(/  /g, "&nbsp;&nbsp;");
            rawText = rawText.replace(/(\t|\&#09);/g, "&nbsp;&nbsp;&nbsp;&nbsp;");
            rawText = rawText.replace(/\&lt;WBR\/\&gt;/g, "<WBR/>");
            rawText = rawText.replace(/\&lt;wbr\/\&gt;/g, "<wbr/>");
			rawText = rawText.replace(/\&amp;nbsp;/g, "&nbsp;");
            rawText = rawText.replace(/\&amp;lt;B\&amp;gt;/g, "<B>");
            rawText = rawText.replace(/\&amp;lt;b\&amp;gt;/g, "<b>");
            rawText = rawText.replace(/\&amp;lt;\/B\&amp;gt;/g, "</B>");
            rawText = rawText.replace(/\&amp;lt;\/b\&amp;gt;/g, "</b>");
            rawText = rawText.replace(/\&amp;lt;I\&amp;gt;/g, "<I>");
            rawText = rawText.replace(/\&amp;lt;i\&amp;gt;/g, "<i>");
            rawText = rawText.replace(/\&amp;lt;\/I\&amp;gt;/g, "</I>");
            rawText = rawText.replace(/\&amp;lt;\/i\&amp;gt;/g, "</i>");
            rawText = rawText.replace(/\&lt;B\&gt;/g, "<B>");
            rawText = rawText.replace(/\&lt;I\&gt;/g, "<I>");
            rawText = rawText.replace(/\&lt;b\&gt;/g, "<B>");
            rawText = rawText.replace(/\&lt;i\&gt;/g, "<I>");
            rawText = rawText.replace(/\&lt;\/B\&gt;/g, "</B>");
            rawText = rawText.replace(/\&lt;\/I\&gt;/g, "</I>");
            rawText = rawText.replace(/\&lt;\/b\&gt;/g, "</B>");
            rawText = rawText.replace(/\&lt;\/i\&gt;/g, "</I>");
            rawText = rawText.replace(/\&lt;BR\/\&gt;/gi, "<BR/>");
			rawText = rawText.replace(/\&lt;BR \/\&gt;/gi,"<BR/>");
            return rawText;
        },
		getClippedComment:function(value){
			//line breaks cause problems with clipping
			var str = value;
			var index = str.indexOf("<BR",30);
			var index2 = str.indexOf("<br",30);
			if(index != -1){
				str = str.substr(0,index);
				str = str+"...";
			}else if(index2 != -1){
				str = str.substr(0,index2);
				str = str+"...";
			}
			return str;
		},
		restoreTags: function(value){
            var rawText = value;
            rawText = rawText.replace(/\&gt;/gi, ">");
            rawText = rawText.replace(/\&lt;/gi, "<");
			rawText = rawText.replace(/\&amp;/gi, "&");
            rawText = rawText.replace(/\&tilde;/gi, "~");
            rawText = rawText.replace(/\&quot;/gi, "\"");
            rawText = rawText.replace(/\&circ;/gi, "^");
            return rawText;
        }
    });
    
})();
