/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");

dojo.require("dojo.parser");
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._editor.plugins.AlwaysShowToolbar");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("jazz.ui.HoverPopup");
dojo.require("dijit._editor.html");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("dojox.layout.ResizeHandle");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ScriptingClipboardTableView");


(function() { // module container

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var DOWNLOAD_SERVICE_URI 	= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var HoverPopup 				= jazz.ui.HoverPopup;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

/* QM objects */
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var RegistryClient 			= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Editor 					= com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var SelectUtility 			= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var COMMENT_VIEW_TYPE		= "commentView";
var ATTACHMENT_VIEW_TYPE	= "attachmentView";
var COMPARE_VIEW_TYPE		= "compareView";
var ResizeHandle			= dojox.layout.ResizeHandle;
var KeywordClient 			= null;
var ScriptingClipboard		= com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ScriptingClipboardTableView;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/ExecutionScriptElementList.html"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelStep: Constants.getMessage("labelStep"),
		labelComments:Constants.getMessage("labelComments"),
		percentForStepsAndExpected: 100, // best to keep this in synch with COLs in html template
		
		// object initializer
		widgetsInTemplate: true,
		constructor: function(args){
			this._steps = [];
			this._elementMap = {}
			this.prevStepNum = -1;
			this.scriptObjects = [];
			if(args.save){
				this.save = args.save;
			}
		},

		postCreate: function() {
			this._menus = [];
			this.DEFAULT_STEP_TYPE = "Execution Step";
			this.expectedResult_Summary_ID = "_stepSummaryExpectedResult_";
			this.expectedResult_ID = "expectedResult_";
			this.ID_SUMMARY_ROW = this.id+"row_summary_step_";
			this.ID_EDITOR = this.id+"__stepEditor";
			this.ID_DETAIL_EDITOR_DIV = this.id+"row_detail_editor_div_";
			this.ID_EXPECTED_RES_DIV = this.id+this.expectedResult_ID;
			this.ID_TYPE_DROPDOWN2 = this.id+"dropdownIcon2_";
			this.ID_STEP_TYPE = "_stepType";
			this.ID_KW_TYPE = "_kwType";
			this.ID_STEP_SUMMARY = this.id+"_stepSummary_";
			this.ID_STEP_SUMMARY_EXP = this.id+this.expectedResult_Summary_ID;
			this.ID_KW_SUMMARY_CELL = this.id+"_kwSummaryCell";
			this.ID_KW_SUMMARY_EXP_CELL = this.id+"_kwExpectedCell";
			this.ID_KW_SUMMARY = this.id+"_kwSummary";
			this.ID_KW_SUMMARY_EXP = this.id+"_kwExpected";
			this.ID_COMMENT_COL_AREA = this.id+"_commentColArea";
			this.ID_COMMENT_COL_CELL = this.id+"_commentColCell";
			this._tooltips = [];
			this.attachingEditor = false;
			this.imageDisplayType = "";
			this.showCommentsCol = false;
			this.showCompactView = false;
			this.keywordStepsCounter = 0;
			this.onmousemoveEvent = [];
			this.labelRemoveStep = Constants.getMessage("labelRemoveStep");
			this.labelAddToClipboard = Constants.getMessage("labelAddToClipboard");
			this.rowCounter = 0;
			this.keywordType = "KeywordType";
			this.clipboardStepType = "ClipboardStep";
		},
		
		initialize: function(args) {
			if (args.parentController == null) {
				throw new Error("ExecutionScriptElementList#initialize: Missing required parameter 'parentController'");
			}
			var _steps = [];
			if ( args.steps != null && args.steps.length > 0 ) {
				_steps = _steps.concat(args.steps);
			}
			this._steps = _steps;
			if(args.parentCallBack)
				this.parentCallBack = args.parentCallBack;		
			this._initElementTypes();
			this._createSplitContainer();
            this.dndTopic = dojo.subscribe("/dnd/drop",this, "_dndDrop");
			this.dndTopic2 = dojo.subscribe("/dnd/cancel",this,"_dndCancel");            
		},	
		
		isReadOnly: function() {
			if ((this.parentCallBack && dojo.isFunction(this.parentCallBack.isReadOnly))) {
				return this.parentCallBack.isReadOnly();
			}
			return false; //default to non read only mode
		},
		_dndCancel:function(){
			if(!dojo.isIE)
				document.body.style.cursor = "default";
		},
        _dndDrop:function(source,nodes,iscopy,target){
			var _dojo = dojo;
			if(!_dojo.isIE)
				document.body.style.cursor = "default";
			if (target.parent == this._stepsTableBody) {
				if (source) {
					if (nodes[0]["type"] == this.keywordType) {
						var row = target.anchor;
						_dojo.dnd.manager().target = null;
						var item = source.getItem(nodes[0].id);
						if (item) {
							var keyword = item.data.scriptObj;
							setTimeout(_dojo.hitch(this, function(row, keyword){
								row.id = this.ID_SUMMARY_ROW + this.rowCounter;
								this.rowCounter += 1;
								if (row.nextSibling) {
									row.className = "steps-table-row dojoDndItem";
									var rows = this._stepsTableBody.rows;
									this._addKeyword(row, keyword, false,true);
									this._updateStepNum(rows, row.nextSibling.sectionRowIndex);
								}
								else {//drop on click to add step. Remove the click to add and then add it after the dropped keyword
									var targetRow = row.previousSibling;
									this._stepsTableBody.deleteRow(targetRow.sectionRowIndex);
									row.className = "steps-table-row dojoDndItem";
									this._addKeyword(row, keyword, false,true);
									this._appendNewStepLinkRow(document);
								}
								this.setParentDirty();
							}, row, keyword), 0);
						}
					}else if(nodes[0]["type"] == this.clipboardStepType){
						var row = target.anchor;
						_dojo.dnd.manager().target = null;
						var items = [];
						var len = nodes.length;
						for(var i=0;i<len;i++){
							items.push(source.getItem(nodes[i].id).data);
						}
						setTimeout(_dojo.hitch(this, function(row, items){
							var targetRow = row.previousSibling;
							if(targetRow == null)
								targetRow = this._stepsTableBody.rows[0];
							this.addClipboardSteps(targetRow, items, false,row,true);
						},row,items),0);
						
					}else{ // the steps drop is meant for me
						_dojo.dnd.manager().target = null;
						setTimeout(_dojo.hitch(this, "_reOrganizeSteps"), 0);
					}
				}
			}
        },
		_reOrganizeSteps:function(){
			this.setParentDirty();	
			this._preserveEditedContent();
			var newSteps = [];
			var newProps = [];
			var stepNum = 0;
			var stepTableBodyRows = this._stepsTableBody.rows;
			var _steps = this._steps;
			var len = stepTableBodyRows.length-1;
			for(var i = 0; i < len ; i++){
				stepNum = parseInt(stepTableBodyRows[i].cells[0].innerHTML,10)-1;
				var step = _steps[stepNum];
				var newStep = {};
				newStep.content = step.content;
				newStep.properties = step.properties;
				newStep.expectedResult = step.expectedResult;
				newStep.elementType = step.elementType;
				newStep.summary = step.summary;
				newStep.num = i+1;
				//copy the original step attributes but use the itemId of the step in the current position
				newStep.itemId = _steps[i].itemId;
				newSteps.push(newStep);
				stepTableBodyRows[i].cells[0].innerHTML = i+1;
			}
			this._steps = newSteps;
		},
        _createSplitContainer: function() {
			var _dojo = dojo;
			if (!this.isReadOnly()) {
				this._kwView = new com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView({editor: this});
				this._kwContainer.appendChild(this._kwView.domNode);
				this.stepsDndSource = new _dojo.dnd.Source(this._stepsTableBody, {
					accept: [this.id,this.clipboardStepType,this.keywordType],
					creator: _dojo.hitch(this,this._dndCreator,document),
					copyOnly:true,
					withHandles:true,
					delay:20
				});
				this.clipboard = new ScriptingClipboard({editor:this});
				this._kwView.clipboardView.appendChild(this.clipboard.domNode); 
				this.stepsDndSource.getSelectedNodes = _dojo.hitch(this,"getSelectedNodes");
				_dojo.style(this._stepsContainer, "height", "500px");//Make the toolbar always visible
			} else {			
				//if read-only, no need to show keywords
				this._kwContainer.style.display = "none";
				_dojo.removeClass(this._stepsContainer,"steps-container");
				_dojo.style(this._stepsContainer, "height", "auto");
			}
			this._editorContainer.setAttribute("tabIndex", -1);
			
        },
		getSelectedNodes: function(){
		// summary: returns a list (an array) of selected nodes
			var _dojo = dojo;
			var t = new _dojo.NodeList();
			var e = _dojo.dnd._empty;
			var doc = document;
			for(var i in this.stepsDndSource.selection){
				if(i in e){ continue; }
				t.push(_dojo.byId(i,doc));
			}
			t = t.sort(function(a1,a2){
				if(a1.sectionRowIndex < a2.sectionRowIndex)
					return -1;
				else
					return 1;
			});
			return t;	// Array
		},
		
		_showSteps: function() {
			var isReadOnly = this.isReadOnly();
			if (isReadOnly) {
				this.stepBeingEdited = -1;
			}
			dojox.data.dom.removeChildren(this._stepsTableBody);
			var doc = document;
			var _dojo = dojo;
			var onmousemoveEvent = this.onmousemoveEvent;
			var len = onmousemoveEvent.length;
			for(var i=0;i<len;i++){
				_dojo.disconnect(onmousemoveEvent[i]);
			}
			this.onmousemoveEvent = [];
			if (this.stepsDndSource) {
				this.stepsDndSource.clearItems();
			}
			this.rowCounter = 0;
			if ( this._steps != null) {
				var steps = this._steps;
				var len = steps.length ||0;
				var stepBeingEdited=this.stepBeingEdited;
				for ( var i = 0; i < len; i++ ) {
					var step = steps[i];
					step.num = i + 1;
					this._insertStepRow(doc,_dojo,isReadOnly,null, step, (stepBeingEdited == i),null,i);
				}
				this.rowCounter =i;
			}
			
			if (!isReadOnly) {
				this._appendNewStepLinkRow(doc);
			}
			var step1 = _dojo.byId(this.ID_STEP_SUMMARY + 1,doc);
			if(step1)
				step1.parentNode.focus();
				
		},
		
		_getEmptyRow: function(doc) {
			if(!doc){// Fail safe
				doc = document;
			}
			var row = doc.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(doc, span, align) {
			if(!doc){// Fail safe
				doc = document;
			}
			var cell = doc.createElement("td");
			cell.className = "steps-table-cell"
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ) {
				cell.align = align;
			}
			return cell;
		},
		
		_buildDetailRow: function(doc,step,editable) {
			//build details row
			var detailsDiv = doc.createElement("div");
			detailsDiv.id = this.ID_DETAIL_EDITOR_DIV + step.num;
			if(!editable)
				detailsDiv.className = "step-detail-container";
			else
				detailsDiv.className = "step-detail-container cellEditable";
			if (step && step.content) {
				if(editable || !this.showCompactView)
					detailsDiv.innerHTML = unescape(step.content);
				else 
					detailsDiv.innerHTML = unescape(step.summary);
			}
			return detailsDiv;		
		},
		
		_buildExpectedResultDiv: function(doc,step,editable){
			var detailsDiv = doc.createElement("div");
			detailsDiv.id = this.ID_EXPECTED_RES_DIV + step.num;
			if(!editable)
				detailsDiv.className = "step-detail-container";
			else
				detailsDiv.className = "step-detail-container cellEditable"
			if (step && step.expectedResult) {
				if (editable || !this.showCompactView) 
					detailsDiv.innerHTML = unescape(step.expectedResult);
				else 
					if (!editable && this.showCompactView) {
						if(!step.expectedResult)
							step.expectedResult = "";
						if(!step.expectedResSummary)
							step.expectedResSummary = this._getSummary(step.expectedResult);
						detailsDiv.innerHTML = unescape(step.expectedResSummary);
					}
			}
			return detailsDiv;
		},
		
		_attachEditor: function(doc,_dojo,isDetail, row) {
			var id = null;
			//If the editor is being attached, return
			//If the editor is attached but not loaded, return browser is working on it see RichText#setValue()
			if(this.attachingEditor || (this.editor && !this.editor.isClosed && !this.editor.isLoaded)){
				return;
			}	
			var prevEditorExpectedResult = false;
			if(this.editor){
				var id = this.editor.domNode.id;
				prevEditorExpectedResult = (id.indexOf(this.expectedResult_ID) != -1);
			}	
			this.attachingEditor = true;
			var heightValue= '';
			var sectionRowIndex = row.sectionRowIndex;
			var attachNode;
			if(isDetail)
				attachNode = row.cells[2].childNodes[0].childNodes[0];
			else
				attachNode = row.cells[4].childNodes[0].childNodes[0];
			if(!this.editor){
				if(!this.toolbar || !this.toolbar.domNode){
					//toolbar domnode becomes null when editor cannot be destroyed completely.
					this.toolbar = new dijit.Toolbar();
					dojox.data.dom.removeChildren(this._editorHeader);	
					this._editorHeader.appendChild(this.toolbar.domNode);
				}
				var args = {
					height: '',
					minHeight: '25px',
					parentRow: row,
					focusOnLoad: dojo.isIE ? true : false,
					parentWidget: this,
					toolbar: this.toolbar
				};
				if(this.save){
					args.save = this.save;
				}
				this.editor = new Editor(args, attachNode);
                
                // On FF,need to explicitly set the focus on the editor to show
                // up properly in the first click of a step. The above 'focusOnLoad'
                // does not really do it well. The cursor is never shown even if 
                // the focus is on the editor. Calling onClick directly would get the
                // cursor show up properly.
                if (dojo.isFF) {
                    this.editor.onLoadDeferred.addCallback(this, function(){
                        this.editor.onClick();
                        this.editor.focus();
                    });
                }
			}else{
				if(this.stepBeingEdited == sectionRowIndex && prevEditorExpectedResult != isDetail){//same row same cell
					this.editor.disabled = false;
					this.editor.srcNodeRef = attachNode;
					this.editor.parentRow = row;
					this.editor.open(attachNode);
					this.attachingEditor = false;
					return;
				}
				this.editor.endEditing(true);
				var prevEditorState = this.editor.getState();
				_dojo.removeClass(this.editor.domNode,"step-detail-container");
				var prevId = this.editor.parentRow.sectionRowIndex;
				this.prevStepNum = prevId;
				if (this._steps[prevId] && !this.editor.disabled) {
					var value = this.editor.getValue();
					value = this.wrapAsXhtml(value);
					if(_dojo.isMoz)
						value = value.replace(/<br _moz_editor_bogus_node=[\s\w"]*\/>/gi, "");
					if (prevEditorExpectedResult) {
						this._steps[prevId].expectedResult = escape(value);
						this._steps[prevId].expectedResSummary = this._getSummary();
					}
					else {
						this._steps[prevId].content = escape(value);
						this._steps[prevId].summary = this._getSummary();
					}
					if (prevId != sectionRowIndex) {
						var detailsNode = this._stepsTableBody.rows[prevId].cells[2].childNodes[0].childNodes[0];
						var detailsDiv = this._buildDetailRow(doc,this._steps[prevId]);
						var expectedResNode = this._stepsTableBody.rows[prevId].cells[4].childNodes[0].childNodes[0];
						var expectedResDiv = this._buildExpectedResultDiv(doc,this._steps[prevId]);
						detailsNode.parentNode.replaceChild(detailsDiv, detailsNode);
						expectedResNode.parentNode.replaceChild(expectedResDiv, expectedResNode);
					}
					else 
						if (!prevEditorExpectedResult) {
							var detailsNode = this._stepsTableBody.rows[prevId].cells[2].childNodes[0].childNodes[0];
							var detailsDiv = this._buildDetailRow(doc,this._steps[prevId],true);
							detailsNode.parentNode.replaceChild(detailsDiv, detailsNode);
						}
				}
				this.editor.disabled = false;
				this.editor.srcNodeRef = attachNode;
				this.editor.parentRow = row;
				this.editor.open(attachNode);
			}
			this.stepBeingEdited = sectionRowIndex;
			var step = this._steps[sectionRowIndex];
			var content = isDetail ? (step.content? unescape(step.content):""): (step.expectedResult? unescape(step.expectedResult):"");
			this._changeBGColor(doc,_dojo,row);
			if (content == "" || content == "<br />") 
				setTimeout(_dojo.hitch(this, this._updateToolBarState, prevEditorState), 100);//Not calling directly IE is not ready for it.
			else {
				this.editor.replaceValue(content);
				if(dojo.isIE){
					//IE Doc is just not ready for setting the focus, hang on for a bit
					setTimeout(dojo.hitch(this.editor, "focus"), 20);
				}else{
					this.editor.focus();
				}
				this.attachingEditor = false;
			}
		},
		
		_updateToolBarState: function(state){
			if(state){
				this.editor.setState(state);
				this.editor.focus();
			}
			this.attachingEditor = false;
		},
		
		_insertRowinBetween:function(stepNum,/*boolean*/before,stepType,/*in case of keyword*/keyword){
			var steps = this._steps||[];
			var newStep = {};
			newStep.elementType = this._getElementTypeByName(stepType);
			newStep.content = "";
			newStep.summary = "";
			newStep.expectedResult = "";
			if(keyword)
				newStep.script = keyword;
			if (before) {
				steps.splice(stepNum,0,newStep);
			}else {
				steps.splice(stepNum+1,0,newStep);
			}
			var len = steps.length;
			for ( var i = 0; i < len; i++ ) {
				steps[i].num = i+1;
			}
		},
		
		_handleRowInsert:function(currentRow,before){
			var doc = document;
			var _dojo = dojo;
			this._preserveEditedContent();
			var stepNum = currentRow.sectionRowIndex;
			if(!before)
				before = false;
			this._insertRowinBetween(stepNum,before,"Execution Step");
			var row  = null;
			var _stepsTableBody = this._stepsTableBody;
			if (before) {
				this.prevStepNum = stepNum + 1;
				if (this.stepsDndSource) {
					row = this._getEmptyRow(doc);
					row.id = this.ID_SUMMARY_ROW + this.rowCounter;
					this.rowCounter +=1;
					this.stepsDndSource.insertNodes(false, [row], true, currentRow);
					row = currentRow.previousSibling;
				}else 
					row = _stepsTableBody.insertRow(stepNum);
				this._insertStepRow(doc,_dojo,this.isReadOnly(),row, this._steps[stepNum], true);
			}else {
				this.prevStepNum = stepNum;
				if (this.stepsDndSource) {
					row = this._getEmptyRow(doc);
					row.id = this.ID_SUMMARY_ROW + this.rowCounter;
					this.rowCounter +=1;
					this.stepsDndSource.insertNodes(false, [row], false, currentRow);
					row = currentRow.nextSibling;
				}else 
					row  = _stepsTableBody.insertRow(stepNum+1);
				this._insertStepRow(doc,_dojo,this.isReadOnly(),row, this._steps[stepNum+1], true);
			}
			this._updateStepNum(_stepsTableBody.rows,stepNum+1);
			this.setParentDirty();
		},
		_handleAddClick: function(e, currentRow) {
			var _dojo = dojo;
			if(e)
				_dojo.stopEvent(e);
			var doc = document;
			var row = null;
			var newRow = false;
			if(currentRow){
				var prevEditorExpectedResult = false;
				if(this.editor){
					var id = this.editor.domNode.id;
					prevEditorExpectedResult = id.match(this.expectedResult_Summary_ID) || id.match(this.expectedResult_ID);
				}
				if (prevEditorExpectedResult) 
					row = currentRow.nextSibling;
				else {
					this._attachEditor(doc,_dojo,false,currentRow);
					var detailNode = this._stepsTableBody.rows[currentRow.sectionRowIndex].cells[2].childNodes[0].childNodes[0];
					if(detailNode){
						_dojo.addClass(detailNode,"cellEditable");
					}
					return;
				}
				if(row.id == "")
					newRow = true;
				if(row.id != ""){
					if(row.isKeyword){
						return;
					}else{
						this._attachEditor(doc,_dojo,true,row);
						var expectedNode = this._stepsTableBody.rows[row.sectionRowIndex].cells[4].childNodes[0].childNodes[0];
						if (expectedNode) 
							_dojo.addClass(expectedNode, "cellEditable");
					}
				}	
			}	
			if(e){
				newRow = true;
				row = e.currentTarget;					
			}
			if(newRow){
				if(row.add_click_handle)
					dojo.disconnect(row.add_click_handle);
				if(row.add_enter_handle)
					dojo.disconnect(row.add_enter_handle);
				dojox.data.dom.removeChildren(row);
				var isReadOnly = this.isReadOnly();
				this._insertStepRow(doc,_dojo,isReadOnly,row, null, true,null,this.rowCounter);
				this.rowCounter +=1;
				var lastRow = this._appendNewStepLinkRow(doc);
				this._stepsContainer.scrollTop = lastRow.offsetTop;
				
			}
			if(this.prevStepNum != -1){
				this.prevStepNum = row.sectionRowIndex;
				this._createCurrentProperties(this._steps[row.sectionRowIndex].properties);
			}else{
				this.prevStepNum = row.sectionRowIndex;
			}
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]:null;
		},
		
		_handleEditClick: function(e, stepNum, currentRow) {
			//required for multi-select of steps
			if(e && (e.ctrlKey||e.shiftKey))
				return;
			//defect 23923
			if (e.target && (e.target.nodeName == "IMG" || e.target.nodeName == "A" ||(e.target.nodeName == "SPAN" && e.target.id == "imageLink" ))) {
				if(e.stopPropagation) //FF
					e.stopPropagation();
				e.cancelBubble = true;//IE
				return;
			}
			dojo.stopEvent(e);
			var row = null;
			if(currentRow)
				row = currentRow;
			if(e){
				row = e.currentTarget.parentNode;
			}
			var doc = document;
			if(this.prevStepNum != -1){
				if(currentRow){
					this.prevStepNum = currentRow.sectionRowIndex
				}else
					this.prevStepNum = row.sectionRowIndex;
				this._createCurrentProperties(this._steps[row.sectionRowIndex].properties);
			}
			else{
				this.prevStepNum = row.sectionRowIndex;
				this._createCurrentProperties(this._steps[row.sectionRowIndex].properties);
			}
			if(this.editor && this.editor.domNode.parentNode.id == e.currentTarget.firstChild.id && !this.editor.disabled)
				return;
			var childIds = e.currentTarget.firstChild.id ? e.currentTarget.firstChild.id.split(this.ID_STEP_SUMMARY_EXP) : [];
			var focusNodeId = childIds.length > 1 ? this.ID_EXPECTED_RES_DIV : this.ID_DETAIL_EDITOR_DIV;
			var isReadOnly = this.isReadOnly();
			dojox.data.dom.removeChildren(row);
			var _dojo = dojo;
			var rowId = row.id;
			var counter = rowId.split(this.ID_SUMMARY_ROW)[1];
			this._insertStepRow(doc,_dojo,isReadOnly,row, this._getStepForRow(row), true, focusNodeId,counter);
			if (focusNodeId != this.ID_EXPECTED_RES_DIV) {
				var expectedNode = this._stepsTableBody.rows[row.sectionRowIndex].cells[4].childNodes[0].childNodes[0];
				if (expectedNode) 
					_dojo.addClass(expectedNode, "cellEditable");
			}else{
				var detailNode = this._stepsTableBody.rows[row.sectionRowIndex].cells[2].childNodes[0].childNodes[0];
				if(detailNode){
					_dojo.addClass(detailNode,"cellEditable");
				}
			}
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]: null;
		},	
		_changeBGColor: function(doc,_dojo,row){
			if(this.prevStepNum != -1){
				var prevRow = this._stepsTableBody.rows[this.prevStepNum];
				if(prevRow){
					_dojo.addClass(prevRow,"steps-table-row");
					_dojo.removeClass(prevRow, "selected-row");
				}
				if (prevRow) {
					_dojo.removeClass(prevRow, "dojoDndItemAnchor");
					_dojo.removeClass(prevRow, "dojoDndItemSelected");
				}
			}
			if(row){
				_dojo.addClass(row, "selected-row");
			}
		},
		
		updateStepType: function(index){
			if(this.changedStepId != null){
				this.setParentDirty();	
				var img = this._stepsTableBody.rows[this.changedStepId].cells[1].childNodes[0];
				var step=this._steps[this.changedStepId];
				if (index.abrv == "rp") {
					step.elementType = this._getElementTypeByName("Reporting Step");
				}
				else {
					step.elementType = this._getElementTypeByName("Execution Step");
				}	
				img.title = step.elementType.displayName;
				img.alt= step.elementType.displayName;
				img.src= step.elementType.iconUrl;
				img.stepType = step.elementType.name;
				this.changedStepId = null;		
			}
		},
		_updatePasteCompareProperty:function(properties){
			if(this.stepBeingEdited != -1){
				var stepNum = this.stepBeingEdited;
				var step = this._steps[stepNum];
				var stepProperties = step.properties;
				var pasteComparePropertyFound = false;
				if(stepProperties){
					if(properties && properties.length >0){
						var len = stepProperties.length;
						for(var i=0;i<len;i++){
							var stepProp=stepProperties[i];
							if(stepProp.propertyType == properties[0]){
								stepProp.propertyName = properties[1];
								stepProp.propertyValue = properties[2];
								if(properties[2] == "")
									stepProperties.splice(i,1);
								pasteComparePropertyFound = true;
								break;
							}
						}
					}
				}
				else
					stepProperties = [];
				if(properties && !pasteComparePropertyFound && properties[2] != ""){
					stepProperties.push({
						propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]
						});							
				}
				step.properties = stepProperties;
				this._updateProperties(stepNum);
			}
		},		
		
		_updateCommentProperty:function(properties,index){
			if(this.stepBeingEdited != -1 || index != null){
				var stepNum = index!= null?index:this.stepBeingEdited;//if index provided use that
				var step = this._steps[stepNum];
				var stepProperties = step.properties;
				var commentPropertyFound = false;
				if(stepProperties){
					if(properties && properties.length >0){
						var len = stepProperties.length;
						for(var i=0;i<len;i++){
							var stepProp=stepProperties[i];
							if(stepProp.propertyType == properties[0]){
								stepProp.propertyName = properties[1];
								stepProp.propertyValue = properties[2];
								if(properties[2] == "")
									stepProperties.splice(i,1);
								this._steps[stepNum].comments = {propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]};
								commentPropertyFound = true;
								break;
							}
						}
					}
				}
				else
					stepProperties = [];
				if(properties && !commentPropertyFound && properties[2] != ""){
					stepProperties.push({
						propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]
						});	
					step.comments = {propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]};						
				}
				step.properties = stepProperties;
				this._updateProperties(stepNum);
				if (properties) {
					var commentArea = this._stepsTableBody.rows[stepNum].cells[5].childNodes[0];
					if(commentArea)
						commentArea.value = properties[2];
				}
			}
		},
		
		_updateAttachmentProperty:function(properties,removedAttachments){
			if(this.stepBeingEdited != -1){
				var stepNum = this.stepBeingEdited;
				var step = this._steps[stepNum];
				var stepProperties = step.properties;
				var newProperties = [];
				if(stepProperties){
					var len = stepProperties.length;
					for(var i=0;i<len;i++){
						if(stepProperties[i].propertyType != ATTACHMENT_VIEW_TYPE){
							newProperties.push(stepProperties[i]);
						}
					}
				}
				if(properties && properties.length > 0){
					for(var j=0;j<properties.length;j=j+3){
						newProperties.push({propertyType:properties[j],propertyName:properties[j+1],propertyValue:properties[j+2]
						});
					}
				}
				step.properties = newProperties;
				if(!this.removedAttachments)
					this.removedAttachments = new Array();
				this.removedAttachments[stepNum] = removedAttachments;
				this._updateProperties(stepNum);
			}		
		},

		_updateProperties:function(stepNum){
			var doc = document;
			var _dojo = dojo;
			this.setParentDirty();	
			this._createCurrentProperties(this._steps[stepNum].properties);
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[stepNum]:null;
			var attachCell = this._stepsTableBody.rows[stepNum].cells[6];
			var commentCell = this._stepsTableBody.rows[stepNum].cells[7];
			var compareCell = this._stepsTableBody.rows[stepNum].cells[8];
			var propshtml = this._createPropertiesHtml(doc,_dojo,stepNum,this.currentProperties);
			if(attachCell)
				attachCell.parentNode.replaceChild(propshtml[0],attachCell);
			if(commentCell)
				commentCell.parentNode.replaceChild(propshtml[1],commentCell);
			if(compareCell)
				compareCell.parentNode.replaceChild(propshtml[2],compareCell);
		},
		
		_getProperties:function(){
			return [this.currentProperties,this.currentRemovedAttachments];
		},
		
		_appendNewStepLinkRow: function(doc) {
			var row = this._getEmptyRow(doc);
			var icon = this._getEmptyCell(doc);
			var image = doc.createElement('img');
			image.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/images/icons/elcl16/add.gif");
			icon.appendChild(image);
			row.appendChild(icon);
			var cell = this._getEmptyCell(doc, 10);
			var anchor = doc.createElement('a');
			anchor.href = "#";
			anchor.appendChild(doc.createTextNode(Constants.getMessage("labelClickToAdd")));	
			cell.style.color = "#1E9494";
			anchor.setAttribute("tabIndex", 0);
			cell.appendChild(anchor);
			row.appendChild(cell);
			this._stepsTableBody.appendChild(row);
			if (!this.isReadOnly()) {
				row.add_click_handle = dojo.connect(row, "onclick",this, "_handleAddClick");
				row.add_enter_handle = dojo.connect(row, "onkeypress",this, "_keyPressHandler");
			}
			return row;
		},
		_keyPressHandler:function(e){
			if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE) {
                //perform the open new section dialog on ENTER pressed 
                this._handleAddClick(e);
            }
		},
	    _dndCreator:function(doc,row,hint){
			if(row.id){
				var rowId = row.sectionRowIndex+1;
	            if(hint == "avatar"){
					this._preserveEditedContent();
					if(!dojo.isIE)
						doc.body.style.cursor = "not-allowed";
					var textDiv = doc.createElement("div");
					textDiv.innerHTML = rowId + " "+unescape(this._steps[rowId - 1].summary);
					return {node: textDiv, data: row, type: [this.id]};
	            }
	           return {node: row, data: row, type: [this.id]};				
			}
			var newRow = doc.createElement("tr");	
            return {node: newRow, data: null, type: []};
        },
	
		_createPropertiesHtml: function(doc,_dojo,stepNum,properties){
			var attachCell = this._getEmptyCell(doc);
			attachCell.align = "right"; 
			var attachmentsHtml = doc.createElement("span");
			var attachmentsHtmlContent = attachmentsHtml.appendChild(doc.createElement("table"));
			
			var commentCell = this._getEmptyCell(doc);
			commentCell.align = "right";
			_dojo.addClass(commentCell,"commentProp");
			var commentsHtmlContent = doc.createElement("span");

			var compareCell = this._getEmptyCell(doc);
			compareCell.align = "right";
			var compareHtmlContent = doc.createElement("span");
			
			var attachmentFound = false;
			var commentFound = false;
			var compareFound = false;
			var attachmentCount= 0;
			
			if(properties) {
				var len = properties.length||0;
				for(var i=0;i<len;i++){
					switch(properties[i].propertyType){
						case ATTACHMENT_VIEW_TYPE:
							if(attachmentFound == false){
								var attachImg = doc.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachCell.appendChild(attachImg);
								attachImg.setAttribute("tabIndex", 0);
								attachmentFound = true;
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow(doc);
							var attachmentsHtmlContentCell = this._getEmptyCell(doc);
							var attachmentsAnchor = doc.createElement("a");
							attachmentsAnchor.target = "_blank";
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							attachmentsAnchor.appendChild(doc.createTextNode(attachmentsText));
							attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							_dojo.style(attachmentsAnchor,"fontSize","0.7em");
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;
							
						case COMMENT_VIEW_TYPE:
							if(stepNum != null && this._steps[stepNum])
								this._steps[stepNum].comments = properties[i];
							if(commentFound)
								dojox.data.dom.removeChildren(commentsHtmlContent);
							commentFound = true;
							commentsHtmlContent.appendChild(doc.createTextNode(properties[i].propertyValue));
							commentImg = doc.createElement("img");
							commentImg.alt= Constants.getMessage("labelComment");
							commentImg.src = ImageCache.COMMENT;
							commentImg.className = "type-image";
							commentImg.setAttribute("tabIndex", 0);
							commentCell.appendChild(commentImg);
							break;
						
						case COMPARE_VIEW_TYPE:
							if(compareFound)
								dojox.data.dom.removeChildren(compareHtmlContent);
							compareFound = true;
							var value = properties[i].propertyValue.replace(/&colon;/g, ":");
							compareHtmlContent.appendChild(doc.createTextNode(value));
							compareImg = doc.createElement("img");
							compareImg.alt= Constants.getMessage("labelComment");
							compareImg.src = ImageCache.COMPARE;
							compareImg.className = "type-image";
							compareImg.setAttribute("tabIndex", 0);
							compareCell.appendChild(compareImg);
							break;
						default:
							//do Nothing
					}
				}	
			}
			if(attachmentCount>0){
				var tooltip = null;
				var _attachmentTooltipSpan = doc.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = doc.createTextNode("("+attachmentCount+")");
				_dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
				this._tooltips.push(tooltip);
			}
			if(commentFound ===true){
				var tooltip = null;
				var _commentTooltipSpan = doc.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);
				this._tooltips.push(tooltip);				
			}			
			if(compareFound ===true){
				var tooltip = null;
				var _compareTooltipSpan = doc.createElement("span");
				compareCell.appendChild(_compareTooltipSpan);
				tooltip = new HoverPopup({around: [compareImg],html:compareHtmlContent.innerHTML}, _compareTooltipSpan);
				this._tooltips.push(tooltip);				
			}
			return [attachCell,commentCell,compareCell];
		},			
					
		_insertStepRow: function(doc,_dojo,isReadOnly,targetRow, step, editable, focusNodeId,counter) {
			editable = editable != null && editable == true ? true : false ;
			if(step == null){
				this.setParentDirty();	
			}
			var stepNum = step != null ? step.num : (targetRow == null ? this._steps.length + 1 : targetRow.sectionRowIndex+1);
			if (targetRow == null) {
				//build empty target row
				targetRow = this._getEmptyRow(doc);
				targetRow.id = this.ID_SUMMARY_ROW + counter;
				if (this.stepsDndSource) {
				    this.stepsDndSource.insertNodes(false,[targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			} else if (step == null) {
				//new step - (add clicked)	
				step = {num: stepNum};
				this._steps.push(step);	
				targetRow.id = this.ID_SUMMARY_ROW + counter;
				if (this.stepsDndSource) {
			    	this.stepsDndSource.insertNodes(false,[targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			}
			if(step.elementType && step.elementType.name == "Keyword"){
				var keywordId = null;
				var keywordExternalId = null;
				var stepProps = step.properties;
				var len = stepProps.length;
				for(var i=0;i<len;i++){
					if(stepProps[i].propertyType=="keyword"){
						if(stepProps[i].propertyName == "keywordExternalId")
							keywordExternalId = stepProps[i].propertyValue;
						else if(stepProps[i].propertyName == "keywordId")
							keywordId = stepProps[i].propertyValue;
						break;
					}
				}
				if(!keywordId && !keywordExternalId)
					return;
				if (keywordId != null) {
					var keyword = this.scriptObjects[keywordId];
					if (keyword) {
						this._addKeyword(targetRow, keyword, true,false);
						return;
					}
				}
				var self = this;
				var callbackObj = {
					success: function(keywords){
						self._addKeyword(targetRow, keywords[0], true,false);
					},
					failure: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				if (KeywordClient == null){
					KeywordClient = com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient;
				}
				if (keywordId != null) {
					KeywordClient.getKeywordDTO(responseHandler, {
						id: keywordId,
						includeArchived: true
					});
				}
				else if (keywordExternalId != null) {
					KeywordClient.getKeywordDTO(responseHandler, {
						externalId: keywordExternalId,
						includeArchived: true
					});
				}
				return;
			}
			var fragment = doc.createDocumentFragment();
			var numCell = this._getEmptyCell(doc);
			numCell.align = "center";
			numCell.innerHTML = stepNum;
			_dojo.addClass(numCell,"dojoDndHandle");
			fragment.appendChild(numCell);
			this.connect(numCell, "onclick", function(e){
				this.prevStepNum = e.currentTarget.parentNode.sectionRowIndex;
				_dojo.stopEvent(e);
			});
			var typeCell = doc.createElement("td");
			typeCell.align = "left";
			typeCell.vAlign = "center";
			var typeElement = null;
			if ( editable ) {
				//create & populate a select element
				typeElement = doc.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + counter;
				var elementType;
				if(this._elementMap && step.elementType == null){
					elementType = this._getElementTypeByName("Execution Step");
				}else{
					elementType = this._getElementTypeByName(step.elementType.name);
				}
				step.elementType = elementType;
				var displayName = elementType.displayName;
				typeElement.title = displayName;
				typeElement.alt= displayName;
				typeElement.src= elementType != null ? elementType.iconUrl : null;
				typeElement.className = "type-image";
				typeElement.stepType = elementType.name;
			} else {
				var elementType = this._getElementTypeByName(step.elementType.name);
				step.elementType  = elementType;
				typeElement = doc.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + step.num;
				var displayName = elementType.displayName;
				typeElement.title = displayName;
				typeElement.alt= displayName;
				typeElement.src= elementType.iconUrl
				typeElement.className = "type-image";
				typeElement.stepType = elementType.name;
			}
			typeElement.align = "right";
			typeCell.appendChild(typeElement);
			typeCell.className = "steps-table-cell-image";
			fragment.appendChild(typeCell);
			
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc);
			_dojo.addClass(descriptionCell,"dojoDndHandle steps-table-cell-detail");
			var descriptionElement = doc.createElement('div');
			descriptionElement.id = this.ID_STEP_SUMMARY + counter;
			this.onmousemoveEvent.push(_dojo.connect(descriptionElement, "onmousemove",function(e){
				_dojo.stopEvent(e);
			}));
			if(this.descMaxWidth)
				descriptionElement.style.maxWidth = this.descMaxWidth+"px";
			var detailsDiv = this._buildDetailRow(doc,step,editable);
			descriptionElement.appendChild(detailsDiv);	
			descriptionCell.appendChild(descriptionElement);
			fragment.appendChild(descriptionCell);
						
			//Empty cell for resizer
			var emptyCell = this._getEmptyCell(doc);
			fragment.appendChild(emptyCell);
			
			//expected cell
			var expectedResultCell = this._getEmptyCell(doc);
			_dojo.addClass(expectedResultCell,"dojoDndHandle steps-table-cell-detail");
			var expectedResultElement = null;
			expectedResultElement = doc.createElement('div');
			expectedResultElement.id = this.ID_STEP_SUMMARY_EXP + counter;
			this.onmousemoveEvent.push(_dojo.connect(expectedResultElement, "onmousemove",function(e){
				_dojo.stopEvent(e);
			}));
			if (this.expMaxWidth) {
				expectedResultElement.style.maxWidth = this.expMaxWidth + "px";
			}
			var expectedResultDiv = this._buildExpectedResultDiv(doc,step,editable);
			expectedResultElement.appendChild(expectedResultDiv);
			expectedResultCell.appendChild(expectedResultElement);
			fragment.appendChild(expectedResultCell);
			var properties= null;
			this._createCurrentProperties(step.properties);
			if(this.currentProperties.length != 0)
				properties = this.currentProperties;
			var propshtml = this._createPropertiesHtml(doc,_dojo,stepNum-1,properties);
			
			//comment cell
			var commentColCell = this._getEmptyCell(doc);
			var commentArea = doc.createElement("textarea");
			commentArea.id = this.ID_COMMENT_COL_AREA+counter;
			
			commentArea.value = step.comments?step.comments.propertyValue:"";
			this.connect(commentArea,'onblur',dojo.hitch(this,function(e){
				this._updateCommentProperty([COMMENT_VIEW_TYPE,"comment",e.target.value],e.target.parentNode.parentNode.sectionRowIndex);
				if(e.stopPropagation) //FF
					e.stopPropagation();
				e.cancelBubble = true;//IE
				return;
			}));
			//DND Container doesnt allow this event to work in IE. so need to cancel bubble
			this.connect(commentArea,"onselectstart",function(e){
				if(e.stopPropagation) //FF
					e.stopPropagation();
				e.cancelBubble = true;//IE
				return;
			});
			commentColCell.appendChild(commentArea);
			commentColCell.align = "right";
			fragment.appendChild(commentColCell);
			commentColCell.id = this.ID_COMMENT_COL_CELL+counter;
			_dojo.addClass(commentColCell,"commentArea");
						
			//Properties
			fragment.appendChild(propshtml[0]);
			fragment.appendChild(propshtml[1]);
			fragment.appendChild(propshtml[2]);
			
			var dropdownCell2 = doc.createElement("td");
			fragment.appendChild(dropdownCell2);		
			//show remove action button, if not in read-only mode
			var dropdown2=null;
			if (!isReadOnly){
				dropdown2 = doc.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + step.num;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				dropdownCell2.className = "steps-table-cell-image";
				dropdown2.setAttribute("tabIndex", 0);
				descriptionCell.setAttribute("tabIndex", 0);
				descriptionCell.edit_click_handle = this.connect(descriptionCell, "onclick", "_handleEditClick");
				descriptionCell.edit_enter_handle = this.connect(descriptionCell, "onkeypress", 
					function(e){
						if (e.keyCode == _dojo.keys.ENTER || e.keyCode == _dojo.keys.SPACE)
							this._handleEditClick(e);
					});
				expectedResultCell.setAttribute("tabIndex", 0);
				expectedResultCell.edit_click_handle = this.connect(expectedResultCell, "onclick", "_handleEditClick");
				expectedResultCell.edit_enter_handle = this.connect(expectedResultCell, "onkeypress", 
					function(e){
						if (e.keyCode == _dojo.keys.ENTER || e.keyCode == _dojo.keys.SPACE)
							this._handleEditClick(e);
					});	
			}
			targetRow.appendChild(fragment);
			if ( editable && (focusNodeId == this.ID_DETAIL_EDITOR_DIV || !focusNodeId)) {
				setTimeout(_dojo.hitch(this, "_attachEditor", doc,_dojo,true, targetRow), 10);
			}
			if ( editable && focusNodeId == this.ID_EXPECTED_RES_DIV) {
				setTimeout(_dojo.hitch(this, "_attachEditor", doc,_dojo,false, targetRow), 10);
			}		
			if (!isReadOnly && dropdown2){//Create the menus lazily, decreases initial load time
				this.connect(dropdown2, "onclick", _dojo.hitch(this, "_openStepMenu", false, null, null));
				this.connect(dropdown2, "onkeypress", _dojo.hitch(this, "_openStepMenu", true, null, null));
			}
		},
		
		_openStepMenu: function(keyStroke, isKeyword, keywordId, e){
			if(keyStroke){
				if(!(e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.DOWN_ARROW)){
					return;
				}
			}
			var ele = e.currentTarget;
			if(!ele.insertMenu){//Create if does not exist
				var row = ele.parentNode.parentNode;
				if(keywordId)
					this._createInsertContextMenu( ele,row, isKeyword, keywordId);
				else
					this._createInsertContextMenu( ele,row);
			}
			ele.insertMenu._openMyself(e);
			dojo.stopEvent(e);
		},
		
		_insertKeyword:function(doc,targetRow,keywordName,script,stepNum,keywordId){
			var _dojo = dojo;
			var labelKeyword = Constants.getMessage("labelKeyword");
			var numCell = this._getEmptyCell(doc);
			numCell.align = "center";
			numCell.innerHTML = stepNum;
			_dojo.addClass(numCell,"dojoDndHandle");
			var fragment = doc.createDocumentFragment();
			fragment.appendChild(numCell);
			this.connect(numCell, "onclick", function(e){
				this.prevStepNum = e.currentTarget.parentNode.sectionRowIndex;
				_dojo.stopEvent(e);
			});	
			targetRow.isKeyword = true;
			//step type cell
			var typeCell = this._getEmptyCell(doc);
			typeCell.align = "left";
			typeCell.vAlign = "top";
			var typeElement = null;
			typeElement = doc.createElement("img");
			typeElement.id = this.ID_KW_TYPE + stepNum;
			typeElement.title = labelKeyword;
			typeElement.alt= labelKeyword;
			typeElement.src= this._getElementTypeByName("Keyword").iconUrl;
			typeElement.stepType = "Keyword";
			typeElement.className = "type-image";			
			typeCell.appendChild(typeElement);			
			fragment.appendChild(typeCell);
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc,7);	
			var descriptionElement = doc.createElement("table");
			var descriptionElementBody = doc.createElement("tbody");
			descriptionElement.width = "100%";
			descriptionElement.style.borderSpacing = 0;
			var descriptionRow = this._getEmptyRow(doc);
			var descriptionInnerCell = this._getEmptyCell(doc, 8);
			var detailsDiv = doc.createElement('div');
			detailsDiv.innerHTML = keywordName;
			descriptionInnerCell.appendChild(detailsDiv);
			descriptionRow.appendChild(descriptionInnerCell);
			descriptionElementBody.appendChild(descriptionRow);
			descriptionElement.appendChild(descriptionElementBody);
			descriptionCell.appendChild(descriptionElement);
			fragment.appendChild(descriptionCell); 
			descriptionCell.setAttribute("tabIndex", 0);
			_dojo.addClass(descriptionCell,"dojoDndHandle");			
			this.connect(descriptionElement, "onclick", function(e){
				this.prevStepNum = e.currentTarget.parentNode.parentNode.sectionRowIndex;
				_dojo.stopEvent(e);
			});			
			//script statements
			if(script && script.elements && !this.showCompactView){
				var len = script.elements.length;
				var fragment2 = doc.createDocumentFragment();
//				var keywordCellWidth = this.keywordCellWidth
//				var keywordDescWidth = this.keywordDescWidth;
//				var keywordExpWidth = this.expMaxWidth + "px";
//				var keywordExpStepsMaxWidth = (this.expMaxWidth-5)+"px";
				var keywordStepsCounter = this.keywordStepsCounter;
				for(var i=0;i<len;i++){
					var element = script.elements[i];
					var fragment3 = doc.createDocumentFragment();
					var keywordStepsRow = this._getEmptyRow(doc);
					var typeCell2 = this._getEmptyCell(doc);
					_dojo.style(typeCell2,"width","16px");
					typeElement = doc.createElement("img");
					typeElement.id = this.ID_KW_TYPE + stepNum;
					typeElement.title = labelKeyword;
					typeElement.alt= labelKeyword;
					typeElement.src= this._getElementTypeByName(element.elementType.name).iconUrl;
					typeElement.className = "type-image";
					typeElement.stepType = element.elementType.name;
					typeCell2.appendChild(typeElement);
					fragment3.appendChild(typeCell2);
					var keywordCell = this._getEmptyCell(doc);
					var keywordSteps = doc.createElement('div');
					keywordSteps.innerHTML = element.content ? unescape(element.content) : "";
					keywordCell.appendChild(keywordSteps);
					keywordCell.id = this.ID_KW_SUMMARY_CELL + keywordStepsCounter;
					keywordSteps.id = this.ID_KW_SUMMARY + keywordStepsCounter;
//					keywordCell.width = keywordCellWidth;
//					keywordSteps.style.maxWidth = keywordDescWidth;
					keywordSteps.style.overflow = 'auto';
					_dojo.addClass(keywordCell,"steps-table-cell-detail");
					fragment3.appendChild(keywordCell);
					var keywordExpCell = this._getEmptyCell(doc);
					var keywordExpSteps = doc.createElement('div');
					keywordExpSteps.innerHTML = element.expectedResult ? unescape(element.expectedResult) : "";
					keywordExpCell.appendChild(keywordExpSteps);
					keywordExpCell.id = this.ID_KW_SUMMARY_EXP_CELL + keywordStepsCounter;
					keywordExpSteps.id = this.ID_KW_SUMMARY_EXP + keywordStepsCounter;
//					keywordExpCell.width = keywordExpWidth;
//					keywordExpSteps.style.maxWidth = keywordExpStepsMaxWidth;
					keywordExpSteps.style.overflow = 'auto';
					fragment3.appendChild(keywordExpCell);
					var properties = element.properties;
					var propshtml = this._createPropertiesHtml(doc,_dojo,stepNum-1,properties);
					fragment3.appendChild(propshtml[0]);
					fragment3.appendChild(propshtml[1]);
					fragment3.appendChild(propshtml[2]);
					keywordStepsRow.appendChild(fragment3);
					fragment2.appendChild(keywordStepsRow);
					keywordStepsCounter++;
				}
				this.keywordStepsCounter = keywordStepsCounter;
				descriptionElementBody.appendChild(fragment2);
			}	
			var dropdownCell2 = this._getEmptyCell(doc);
			fragment.appendChild(dropdownCell2);
			if (!this.isReadOnly()) {
				var dropdown2 = doc.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + stepNum;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				_dojo.addClass(dropdownCell2,"steps-table-cell-image");
				dropdown2.setAttribute("tabIndex", 0);
				this.connect(dropdown2, "onclick", _dojo.hitch(this, "_openStepMenu", false, true,keywordId));
				this.connect(dropdown2, "onkeypress", _dojo.hitch(this, "_openStepMenu", true, true,keywordId));				
			}
			targetRow.appendChild(fragment);
		},
		
		_addKeyword: function(targetRow,keyword,replaceCurrent, isDrop) {
			var _steps = this._steps;
			var stepNum =0;
			this._preserveEditedContent();
			var doc = document;
			if (targetRow == null) {
				stepNum = _steps.length;
				var step = {num: stepNum+1};
				_steps.push(step);				
				//build empty target row
				targetRow = this._getEmptyRow(doc);
				targetRow.id = this.ID_SUMMARY_ROW + this.rowCounter;
				this.rowCounter += 1;
				if (this.stepsDndSource) {
					this.stepsDndSource.insertNodes(false, [targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			}else{
				stepNum = targetRow.sectionRowIndex;
				if(replaceCurrent == false){
					this._insertRowinBetween(stepNum,true,"Keyword",keyword.id);
					if (!isDrop && this.stepsDndSource) {
						var row = this._getEmptyRow(doc);
						row.id = this.ID_SUMMARY_ROW + this.rowCounter;
						this.rowCounter +=1;
						this.stepsDndSource.insertNodes(false, [row], true, targetRow);
						targetRow = targetRow.previousSibling;
					}else if(!isDrop)
						targetRow = this._stepsTableBody.insertRow(stepNum);
					}
			}
            if(!_steps[stepNum].properties)
			    _steps[stepNum].properties = [];
			_steps[stepNum].properties.push({
				propertyType: "keyword",
				propertyName: "keywordId",
				propertyValue: keyword.id
			});
			dojox.data.dom.removeChildren(targetRow);
			_steps[stepNum].content=escape(keyword.name);
			_steps[stepNum].expectedResult="";
			_steps[stepNum].summary=escape(keyword.name);
			_steps[stepNum].elementType = this._getElementTypeByName("Keyword");
			_steps[stepNum].script=keyword.defaultScript?keyword.defaultScript.id+'':keyword.manualScript.id+'';
			this._steps = _steps;
			this.scriptObjects[keyword.id] = keyword;
			var script = null;
			if(!keyword.defaultScript || keyword.defaultScript.itemId == keyword.manualScript.itemId)
				script = keyword.manualScript;
			this._insertKeyword(doc,targetRow,keyword.name,script,stepNum+1,keyword.id);
		},
				
		_getStepForRow: function(row) {
			return this._steps[row.sectionRowIndex];			
		},		
		
		getElements: function() {
			return this._steps;
		},			
		
		_initElementTypes: function() {
			var handler = new ServiceResponseHandler(this, "_setElementTypes", "_error");
			RegistryClient.getAllExecutionElementTypes(handler);			
		},
		
		_getElementTypeByName: function(typeName) {
			return this._elementMap[typeName];
		},	
		
		_setElementTypes: function(allTypes) {
			var elementTypes = allTypes;
			var len = elementTypes.length;
			for(var i=0;i<len;i++){
				if(elementTypes[i].name == "Execution Step")
					elementTypes[i].displayName = Constants.getMessage("labelExecutionStep");
				else if(elementTypes[i].name == "Reporting Step")
					elementTypes[i].displayName = Constants.getMessage("labelReportingStep");
				elementTypes[i].iconUrl = ImageCache.getTypeIconURL(elementTypes[i])
				this._elementMap[elementTypes[i].name] = elementTypes[i];	
			}
			setTimeout(dojo.hitch(this, "_showSteps"), 0);
			if (!this.isReadOnly()) {
				this._resizeHandle = new ResizeHandle({
					targetContainer: this.desc_col,
					resizeAxis: 'x',
					minHeight: 0,
					minWidth:150,
					onResize:dojo.hitch(this,"_setColWidths")
				});
				this._resizeHandle.placeAt(this.resizer);
				this._resizeHandle.resizeHandle.className = "stepsResizeHandle";
				this._resizeHandle.animateSizing = false;
			}
		},
		_setColWidths:function(e,useTotalWidth){
			
			var percentForStepsAndExpected = this.percentForStepsAndExpected;
			if (this.showCommentsCol){
				this._col_comments_icon.width = "1px";
				this._col_comments.width = "160px";
			} else {
				this._col_comments_icon.width = "20px";
				this._col_comments.width = "1px"; 
			}

			var descrColWidth = this._col_descr.offsetWidth;
			var descrWidth = this.desc_col.style.width;
			if (!descrWidth) return;
			descrWidth=parseInt(descrWidth,10);
			if (!descrWidth) return;
			if (descrWidth != descrColWidth){
				var totalWidth = descrColWidth+this._col_exp.offsetWidth;
				var descrWidthPct = Math.round(percentForStepsAndExpected*descrWidth/totalWidth); 
				var expWidthPct = percentForStepsAndExpected-descrWidthPct;
				this._col_descr.width = descrWidthPct+"%";
				this._col_exp.width = expWidthPct+"%";
			}
		},
		validateElements: function() {
			this._preserveEditedContent();
			var stepTableBodyRows = this._stepsTableBody.rows;
			var len = this._steps.length;
			var doc = document;
			var _dojo = dojo;
			for ( var i = len; i >0 ; i-- ) {
				if ( !this.onStepSave(stepTableBodyRows[i-1],doc,_dojo) ) {
					return false;
				}
			}
			return true;
		},			
			
		onCancel: function(){
			if(this.parentCallBack)
				this.parentCallBack.setHeaderStatus(Constants.getMessage("msgChangesNotSaved"), Constants.HEADER_STATUS_WARNING);
			else
				alert(Constants.getMessage("msgChangesNotSaved"));
		},
		
		handleRowDelete: function(id, row){
			var doc = document;
			var _dojo = dojo;
			var currentEId = id.split(this.ID_EXPECTED_RES_DIV);
			if(currentEId.length > 1){
				var stepNum = row.sectionRowIndex;
				this._preserveEditedContent();
				this.setParentDirty();
				this._attachEditor(doc,_dojo,true,row);
				var expectedNode = row.cells[4].childNodes[0].childNodes[0];
				if (expectedNode) {
					_dojo.addClass(expectedNode, "cellEditable");
					_dojo.addClass(expectedNode.parentNode,"step-detail-container");
				}
				return;
			}
			var prevRow = row.previousSibling;
			if(!prevRow)
				return;
			if(prevRow && this.prevStepNum != -1){
				this._preserveEditedContent();
				this.setParentDirty();
				this.prevStepNum = prevRow.sectionRowIndex
				this._attachEditor(doc,_dojo,false,prevRow);
				this._createCurrentProperties(this._steps[this.prevStepNum].properties);
				var detailNode = prevRow.cells[2].childNodes[0].childNodes[0];
				if(detailNode){
					_dojo.addClass(detailNode,"cellEditable");
				}
				var curretDetailNode = row.cells[2].childNodes[0].childNodes[0];
				if(curretDetailNode){
					_dojo.removeClass(curretDetailNode,"cellEditable");
					_dojo.addClass(curretDetailNode.parentNode,"step-detail-container");
				}
				var curretExpNode = row.cells[4].childNodes[0].childNodes[0]
				if(curretExpNode){
					_dojo.removeClass(curretExpNode,"cellEditable");
				}
			}
		},
		
		_deleteAction: function(stepNum) {	
			this.setParentDirty();	
			var updatedSteps = [];
			var updatedProperties = [];
			var newRemovedAttachments = [];
			var j = 0;
			this._preserveEditedContent();
			var steps = this._steps;
			var len = steps.length;
			for ( var i = 0; i < len; i++ ) {
				if ( i != (stepNum) ) {
					steps[i].num = j + 1;
					updatedSteps.push(steps[i]);
					newRemovedAttachments = this.removedAttachments? this.removedAttachments[i]:null;
					j=j+1;
				}else{
					this.prevStepNum = stepNum;
				}
			} 
			this._steps = null;
			this._steps = updatedSteps;
			this.removedAttachments = newRemovedAttachments;
			var _stepsTableBody = this._stepsTableBody;
			if(this.stepsDndSource){
				this.stepsDndSource.delItem(_stepsTableBody.rows[stepNum].id);
			}
			_stepsTableBody.deleteRow(stepNum);
			this._updateStepNum(_stepsTableBody.rows,stepNum);
		},
		_preserveEditedContent: function(continueEditing){
			if(this.stepBeingEdited != -1 && this.editor){
				var value = this.editor.getValue();
				value = this.wrapAsXhtml(value);
				if(dojo.isMoz)
					value = value.replace(/<br _moz_editor_bogus_node=[\s\w"]*\/>/gi, "");
				if (!this.editor.domNode.id.match(this.expectedResult_ID) && !this.editor.domNode.id.match(this.expectedResult_Summary_ID)) {
					this._steps[this.stepBeingEdited].content = escape(value);
					this._steps[this.stepBeingEdited].summary = this._getSummary();
				}else {
					this._steps[this.stepBeingEdited].expectedResult = escape(value);
					this._steps[this.stepBeingEdited].expectedResSummary = this._getSummary();
				}
				if (!continueEditing) {
					this.editor.close(true);
					this.stepBeingEdited = -1;
					this.editor.disabled = true;
					this.editor.onNormalizedDisplayChanged();
				}
			}else
				this.stepBeingEdited  = -1;
		},
		onStepSave: function(row ,doc,_dojo) {
			var stepNum = row.sectionRowIndex+1;
			var content = this._steps[stepNum -1].content;
			var expectedResult = this._steps[stepNum -1].expectedResult;
			var summary = this._steps[stepNum -1].summary;
			if ( !content || _dojo.trim(content).length == 0 || unescape(content) === '<br />') {
				// ensure that the step content, expectedResult and its properties are empty before discarding it
				if( stepNum === this._steps.length && !(this._steps[stepNum -1].properties 
						&& this._steps[stepNum -1].properties.length > 0) && 
						(!expectedResult || _dojo.trim(expectedResult).length == 0 || unescape(expectedResult) === '<br />') ){
					this._steps.pop();
					this._stepsTableBody.deleteRow(row.sectionRowIndex);
					return true;
				}else{
					if (this.parentCallBack) {
						this.parentCallBack.setHeaderStatus(Constants.getMessage("msgStepContentRequired", stepNum), 
								Constants.HEADER_STATUS_ERROR);
					}else
						alert(Constants.getMessage("msgStepContentRequired", stepNum));
					this._preserveEditedContent();
					this._attachEditor(doc,_dojo,true,row);
					return false;
				}
			}
			var stepObj = this._steps[stepNum-1];
			if ( stepObj == null ) {
				stepObj = {};
				this._steps.push(stepObj);
			}
			stepObj.num = stepNum;
			var typeNode = row.cells[1].childNodes[0];
			if (typeNode.stepType) 
				stepObj.elementType = this._getElementTypeByName(typeNode.stepType);
			if (summary != null && summary.length > 0) {
				//only send up summary if changed or new
				if (!stepObj.summary || stepObj.summary != summary) {
					stepObj.summary = summary;
				}
			}
			stepObj.content = content?_dojo.trim(content):"";
			stepObj.expectedResult = expectedResult ? _dojo.trim(expectedResult) : "";
			if(stepObj.typeName)
				delete(stepObj.typeName);
			this._createCurrentProperties(this._steps[parseInt(stepNum, 10) -1].properties);
			stepObj.properties = this.currentProperties;
			this.removedAttachments = new Array();
			this.currentRemovedAttachments = null;
			return true;
		},
		
        wrapAsXhtml: function(content) {
            var xhtml = content;
            if (xhtml && dojo.trim(xhtml).length>0) {
                var xhtmlNsUri = "http://www.w3.org/1999/xhtml";
                var xhtmlSafe= new RegExp("^<div[^>]+xmlns=\"" + xhtmlNsUri.replace("/","\\/")); 
                if (!xhtmlSafe.test(xhtml)) {
                    xhtml = "<div xmlns=\"" + xhtmlNsUri + "\">" + xhtml + "</div>";
                }
            }
            return xhtml;
        },
		
        _getSummary:function(text) {
            var summaryText = "";
			var newDiv = document.createElement("div");
			if(text){
				var content = unescape(text);
				content = content.replace(/<STYLE[^>]*>([\s\S]*?)<\/STYLE[^>]*>/gi, '' );
				newDiv.innerHTML = content;
			}else if(this.editor && this.editor.editNode){
				var content = this.editor.editNode.innerHTML;
				content = content.replace(/<STYLE[^>]*>([\s\S]*?)<\/STYLE[^>]*>/gi, '' );
				newDiv.innerHTML = content;
			}
			if(newDiv.innerText)
				summaryText = newDiv.innerText; //IE
			else 	
				summaryText = newDiv.textContent;//FF
			summaryText = escape(summaryText);
			if (summaryText.length > 250) {
				summaryText = summaryText.substring(0, 249);
				var m = summaryText.lastIndexOf('%');
				if(m>244)
					summaryText = summaryText.substring(0, m);					
			}
			if(summaryText == "")
				summaryText = "&nbsp;";
			return summaryText;            
        },
        
		setGlobalSaveInProgress: function(){
			this.prevStepNum = -1;
		},
		
		_createCurrentProperties: function(propertyArray){
			this.currentProperties =[];
			if(propertyArray){
				this.currentProperties = propertyArray;
			}
		},
		
		fClick: function(){
			var callbackObj = this.callback;
			this.callback.changedStepId = this.row.sectionRowIndex;
			if (this.typeId) {
				callbackObj.updateStepType({abrv: this.typeId});
				if(this.typeId == "es"){
					this.focusNode.style.display = "none";
					this.domNode.nextSibling.style.display = "";
				}else{
					this.focusNode.style.display = "none";
					this.domNode.previousSibling.style.display = "";
				}
			}
			
		},

		_createInsertContextMenu:function(node,row,isKeyword,keywordId){
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[node.id]});
			var callback = this;
            pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelInsertStepBelow"), 
				iconClass: "ExecutionStepIcon", 
				row:row,
				callback:callback,
				onClick:function(){
					setTimeout(dojo.hitch(this.callback, "_handleRowInsert", this.row, false), 2);
				}
			}));
			pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelInsertStepAbove"), 
				iconClass: "ExecutionStepIcon", 
				row:row,
				callback:callback,
				onClick:function(){
					setTimeout(dojo.hitch(this.callback, "_handleRowInsert", this.row, true), 2);
				}
			}));
			if(isKeyword){
				pMenu.addChild(new dijit.MenuItem({
					label:Constants.getMessage("labelReplaceWithSteps"), 
					iconClass: "ExecutionStepIcon",
					row:row,
					keywordId:keywordId,
					callback:callback,
					onClick:function(){
						var stepEditor = this.callback;
						var keyword = stepEditor.scriptObjects[this.keywordId];
						if (keyword) {
							var script = keyword.manualScript;
							var index = this.row.sectionRowIndex;
							if (script && script.elements) {
								var len = script.elements.length;
								var steps = stepEditor._steps;
								if (len > 0) {
									var doc = document;
									var _dojo = dojo;
									var isReadOnly = stepEditor.isReadOnly();
									var currentRow = this.row;
									var rowCounter =  stepEditor.rowCounter;
									for (var i = 0; i < len; i++) {
										var step = script.elements[i];
										step.itemId = null;
										step.num = index+1+i;
										steps.splice(index + i, 0, step);
										if (stepEditor.stepsDndSource) {
											var newRow = stepEditor._getEmptyRow(doc);
											newRow.id = stepEditor.ID_SUMMARY_ROW + rowCounter;
											rowCounter += 1;
											stepEditor.stepsDndSource.insertNodes(false, [newRow], true, currentRow);
											newRow = currentRow.previousSibling;
										}else 
											newRow = stepEditor._stepsTableBody.insertRow(index+i);
										stepEditor._insertStepRow(doc,_dojo,isReadOnly,newRow, step, false);
									}
									stepEditor.rowCounter = rowCounter;
									steps.splice(index + i, 1);
									var len2 = steps.length;
									for ( var j = index; j < len2; j++ ) {
										steps[j].num = j+1;
									}
									stepEditor._steps = steps;
									stepEditor._stepsTableBody.deleteRow(index+i);
									stepEditor.parentCallBack._setEditorDirty(true);
								}
							}
						}
					}
				}));
			}else{
				var type = row.cells[1].childNodes[0].stepType;
				var esItem = new dijit.MenuItem({label:Constants.getMessage("labelExecutionStep"), 
					iconClass: "ExecutionStepIcon", row: row, typeId:"es", callback: this, onClick:this.fClick});
				pMenu.addChild(esItem);
	           	var rpItem = new dijit.MenuItem({label:Constants.getMessage("labelReportingStep"), 
					iconClass: "ReportingStepIcon",  row:  row, typeId:"rp", callback: this, onClick:this.fClick});
				if(type == "Execution Step"){
					esItem.focusNode.style.display = "none";
				}else
					rpItem.focusNode.style.display = "none";
				pMenu.addChild(rpItem);
				pMenu.addChild(new dijit.MenuItem({
					label:this.labelAddToClipboard, 
					iconClass: "ExecutionStepIcon", 
					row:row,
					callback:callback,
					onClick:function(e){
						dojo.stopEvent(e);
						setTimeout(dojo.hitch(this.callback, "addToClipboard",this.row), 2);
					}
			}));
			}
			pMenu.addChild(new dijit.MenuItem({
				label:this.labelRemoveStep, 
				iconClass: "RemoveStepIcon", 
				row:row,
				callback:callback,
				onClick:function(e){
					dojo.stopEvent(e);
					setTimeout(dojo.hitch(this.callback, "_deleteAction",this.row.sectionRowIndex), 2);
				}
			}));
            pMenu.startup();
			node.insertMenu = pMenu;
			this._menus.push(pMenu);
			return pMenu;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ExecutionScriptElementEditor#_error");
		},

		uninitialize: function() {
			this._destroyEditor();
			var _dojo = dojo;
			_dojo.unsubscribe(this.dndTopic);
			this.dndTopic = null;
			_dojo.unsubscribe(this.dndTopic2);
			this.dndTopic2 = null;
			if (this.stepsDndSource) {
				this.stepsDndSource.clearItems();
				this.stepsDndSource.destroy();
				this.stepsDndSource = null;
			}
			if(this._resizeHandle)
				this._resizeHandle.destroyRecursive(false);
			var _menus = this._menus;
			var menuLen = _menus.length; 
			for(var j=0;j<menuLen;j++){
				var menu = _menus[j]; 
				if(menu.destroyRecursive){
					menu.destroyRecursive();
				}
			}
			this._menus = [];
			var _tooltips = this._tooltips;
			var tooltipLen = _tooltips.length;
			for(var k=0;k<tooltipLen;k++){
				var tooltip = _tooltips[k];
				if(tooltip.destroyRecursive){
					tooltip.destroyRecursive();
				}
			}
			this.tooltips = [];

			if(this._kwView)
				this._kwView.destroyRecursive();
			var onmousemoveEvent = this.onmousemoveEvent;
			var len = onmousemoveEvent.length;
			for(var i=0;i<len;i++){
				_dojo.disconnect(onmousemoveEvent[i]);
			}
			this.onmousemoveEvent = [];
			if (!this.isReadOnly()) {
				var len = this._stepsTableBody.rows.length;
				if (len > 0) {
					var row = this._stepsTableBody.rows[len - 1];
					if (row.add_click_handle) 
						dojo.disconnect(row.add_click_handle);
					if (row.add_enter_handle) 
						dojo.disconnect(row.add_enter_handle);
				}
			}
		},

		_destroyEditor: function(){
			if(this.editor){
				this.editor.endEditing(true);
				this.editor.destroyRecursive(false);
			}
			this.editor = null;
			this.stepBeingEdited  = -1;
			this._changeBGColor(document,dojo);
			this.attachingEditor = false;
		},

		_getDatapool: function() {
			if(this.parentCallBack) {
				var datapool = this.parentCallBack.getSelectedDataPool();
				return (datapool)? datapool : null;
			}
			return null;
		},

		setParentDirty: function(){
			if(!this.attachingEditor)
				this.parentCallBack._setEditorDirty(true);
		},
		
		_removeAllVariables: function(){
			this._preserveEditedContent();
			var steps = this._steps;
			var len = steps.length;
			var rows = this._stepsTableBody.rows;
			for(var i=0; i<len; i++){
				if (steps[i].content) {
					var content = steps[i].content;
					var modified = false;
					content = unescape(content);
					while (true) {
						var p1 = content.indexOf("<button");
						if (p1 == -1) 
							break;
						modified = true;
						var p2 = content.indexOf("</button>", p1 + 2);
						content = content.substring(0, p1) + content.substring(p2 + 9);
					}
					if (modified) {
						steps[i].content = escape(content);
						this._updateDescription(content, i, rows);
					}
				}
				if (steps[i].expectedResult) {
					var expectedResult = unescape(steps[i].expectedResult);
					var modified2 = false;
					while (true) {
						var p11 = expectedResult.indexOf("<button");
						if (p11 == -1) 
							break;
						modified2 = true;
						var p22 = expectedResult.indexOf("</button>", p11 + 2);
						expectedResult = expectedResult.substring(0, p11) + expectedResult.substring(p22 + 9);
					}
					if (modified2) {
						steps[i].expectedResult = escape(expectedResult);
						this._updateExpected(expectedResult, i, rows);
					}
				}
			}
		},
		_toggleCommentsColumn:function(show){
			var val = null;
			if(show == "show")
				val = true;
			else
				val = false;
			
			if (val != this.showCommentsCol) {
				this.showCommentsCol = val;
				if(val)
					this.comments_col.innerHTML = this.labelComments;
				else
					this.comments_col.innerHTML = "";
				this._setColWidths();
			}
		},
		_changeImageDisplay:function(displayType){
			if(this.imageDisplayType == displayType)
				return;
			this._preserveEditedContent();
			this.imageDisplayType = displayType;
			var steps = this._steps;
			var len = steps.length;
			var rows = this._stepsTableBody.rows;
			var modified = false;
			var doc = document;
			var _dojo = dojo;
			for (var i = 0; i < len; i++) {
				var oldcontent = unescape(steps[i].content);
				var content = this._manageImages(displayType,oldcontent,doc,_dojo);
				if (!steps[i].expectedResult) {
					steps[i].expectedResult = "";
					var expectedResult = null;
				}else {
					var oldexpectedResult = unescape(steps[i].expectedResult);
					var expectedResult = this._manageImages(displayType, oldexpectedResult,doc,_dojo);
				}
				if(!rows[i].isKeyword){
					if (content) {
						modified = true;
						steps[i].content = escape(content);
						this._updateDescription(content, i, rows);
					}
					if (expectedResult) {
						modified = true;
						steps[i].expectedResult = escape(expectedResult);
						this._updateExpected(expectedResult, i, rows);
					}
				}
			}
			if(modified)
				this.setParentDirty();
		},
		_manageImages:function(displayType,content,doc,_dojo){
			if (displayType == "FS") {
					var newDiv = doc.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						var modified = false;
						var len = anchors.length;
						for(var k=0;k<len;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							var spans = anchors[k].getElementsByTagName("SPAN");
							if (images && images.length) { // incase the previous display type was TN
								var realImg = images[0];
								realImg.style.width = "auto";
								realImg.style.height = "auto";
								modified = true;
							}else if (spans && spans.length){ // incase the previous display type was LK
								if(spans[0].id == "imageLink"){
									var realImg = doc.createElement('img');
									realImg.alt = _dojo.trim(spans[0].innerHTML);
									realImg.src = anchors[k].href;
									realImg.style.width = "auto";
									realImg.style.height = "auto";
									anchors[k].replaceChild(realImg,spans[0]);
									modified = true;
								}
							}
						}
						if(modified)
							return dijit._editor.getChildrenHtml(newDiv);
						else
							return null;
					}else
						return null;
				}else if (displayType == "TN") {
					var newDiv = doc.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						var len = anchors.length;
						var modified = false;
						for(var k=0;k<len;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							var spans = anchors[k].getElementsByTagName("SPAN");
							var realImg = null;
							var psuedoImg = doc.createElement('img');//use psudeoImg to get the real height and width of image
							psuedoImg.style.width = "auto";
							psuedoImg.style.height = "auto";
							var spanToReplace = null;
							if (images && images.length) { // incase the previous display type was FS
								realImg = images[0];
								psuedoImg.src = images[0].src;
								modified = true;
							}else if (spans && spans.length){ // incase the previous display type was LK
								if(spans[0].id == "imageLink"){
									psuedoImg.src = anchors[k].href;
									realImg = doc.createElement('img');
									realImg.alt = _dojo.trim(spans[0].innerHTML);
									realImg.src = anchors[k].href;
									spanToReplace = spans[0];
									modified = true;
								}
							}
							if(realImg != null){
								//sometimes we dont get the real width and height. so default to 50
								var width = psuedoImg.width == 0?50:psuedoImg.width;
								var height = psuedoImg.height == 0?50:psuedoImg.height;
								var ratio = height > 0 ? width / height : 1;
								if (height >= 50) {
									realImg.width = (50 * ratio);
									realImg.height = 50;
									realImg.style.width = 50 * ratio + 'px';
									realImg.style.height = 50 + 'px';
								}else if (width >= 50) {
									realImg.width = 50;
									realImg.height = (50 / ratio);
									realImg.style.width = 50 + 'px';
									realImg.style.height = 50 * ratio + 'px';
								}
								if(spanToReplace != null){
									anchors[k].replaceChild(realImg,spanToReplace);								
								}
							}
						}
						if(modified)
							return dijit._editor.getChildrenHtml(newDiv);
						else
							return null;
					}else
						return null;
				}else if (displayType == "LK") {
					var newDiv = doc.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						var len = anchors.length;
						var modified = false;
						for(var k=0;k<len;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							if (images && images.length) {
								var name = images[0].alt;
								var spanElement = doc.createElement('span');
								spanElement.id = "imageLink";
								spanElement.appendChild(doc.createTextNode(' '+name+' '));
								anchors[k].replaceChild(spanElement,images[0]);
								modified = true;
							}
						}
						if(modified)
							return dijit._editor.getChildrenHtml(newDiv);
						else
							return null;
					}else
						return null;
				}
			
		},
		_showCompactView:function(selection){
			var val = null;
			if(selection == "normal"){
				val = false;
			}else
				val = true;
			if (this.showCompactView != val) {
				this.showCompactView = val;
				this._preserveEditedContent();
				var rows = this._stepsTableBody.rows;
				var len = rows.length-1;
				var _steps = this._steps;
				for(var i=0;i<len;i++){
					if (!rows[i].isKeyword) {
						var step = _steps[i];
						if (val) {
							this._updateDescription(unescape(step.summary), i, rows);
							if (!step.expectedResSummary) 
								step.expectedResSummary = this._getSummary(step.expectedResult);
							this._updateExpected(unescape(step.expectedResSummary), i, rows)
						}else{
							this._updateDescription(unescape(step.content), i, rows);
							this._updateExpected(unescape(step.expectedResult), i, rows)
						}
					}
				}
				
			}
		},
		_updateDescription:function(content,index,rows){
			var cell = rows[index].cells[2];
			if (cell && cell.childNodes[0] && cell.childNodes[0].childNodes[0]) {
				cell.childNodes[0].childNodes[0].innerHTML = content;
			}			
		},
		_updateExpected:function(expectedResult,index,rows){
			var cell = rows[index].cells[4];
			if ( cell && cell.childNodes[0] && cell.childNodes[0].childNodes[0]) {
				cell.childNodes[0].childNodes[0].innerHTML = expectedResult;
			}		
		},
		updateSteps:function(steps){
			var len = steps.length;
			for(var i=0;i<len;i++){
				var step = steps[i];
				step.num = i+1;
				step.elementType = this._getElementTypeByName(step.elementType.name);
			}
			this._steps = steps;
		},
		_updateStepNum:function(rows,stepNum){
			var len2 = rows.length-1;
			for(var k=stepNum;k<len2;k++)
				rows[k].cells[0].innerHTML = k+1;
		},
		onActivated:function(){
			if(this.clipboard){
				setTimeout(dojo.hitch(this, function(){
					this.clipboard.onActivated();
				}),10);
			}
		},
		addToClipboard:function(row){
			if(this.clipboard){
				this.clipboard.addSteps([row]);
			}
		},
		addClipboardSteps:function(targetRow,items,replaceCurrent,row,isDrop){
			var _dojo = dojo;
			if(_dojo.isArray(items)){
				var len = items.length;
				var doc = document;
				var isReadOnly = this.isReadOnly();
				var rowCounter =  this.rowCounter;
				var steps = this._steps;
				var _stepsTableBody = this._stepsTableBody;
				var index = targetRow.sectionRowIndex;
				if (!targetRow.id || targetRow.id == "") {
					if(!targetRow.previousSibling)
						targetRow = targetRow.nextSibling;
					else
						targetRow = targetRow.previousSibling;
					_stepsTableBody.deleteRow(index);
					index= targetRow.sectionRowIndex;
					this._appendNewStepLinkRow(doc);
				}
				var stepIndex = index;
				if(isDrop)
					stepIndex = index+1;
				for (var i = 0; i < len; i++) {
					var step = {};
					step.content = items[i].content;
					step.expectedResult = items[i].expectedResult;
					step.elementType = items[i].elementType;
					step.properties = items[i].properties;
					step.summary = items[i].summary;
					step.itemId = null;
					step.num = index+i;
					steps.splice(stepIndex+i, 0, step);
					if (this.stepsDndSource) {
						var newRow = null;
						if (row){ 
							newRow = row;
							newRow.className = "steps-table-row dojoDndItem";
							newRow.id = this.ID_SUMMARY_ROW + rowCounter;
							rowCounter += 1;
							this.stepsDndSource.setItem(newRow.id,{data: newRow, type: [this.id]});
						}else {
							newRow = this._getEmptyRow(doc);
							newRow.id = this.ID_SUMMARY_ROW + rowCounter;
							rowCounter += 1;
							this.stepsDndSource.insertNodes(false, [newRow], true, targetRow);
							newRow = targetRow.previousSibling;
						}
					}else 
						newRow = _stepsTableBody.insertRow(index+i);
					this._insertStepRow(doc,_dojo,isReadOnly,newRow, step, false);
					if(row)
						row = row.nextSibling;
				}
				this.rowCounter = rowCounter;
				if (replaceCurrent) {
					steps.splice(index + i, 1);
					_stepsTableBody.deleteRow(index + i);
				}
				var len2 = steps.length;
				for ( var j = index; j < len2; j++ ) {
					steps[j].num = j+1;
				}
				if(!isDrop && !replaceCurrent && this.stepBeingEdited != -1){
					this.stepBeingEdited = targetRow.sectionRowIndex;
				}else if(replaceCurrent && this.stepBeingEdited == index)
					this.stepBeingEdited = -1;
				var rows = _stepsTableBody.rows;
				this._updateStepNum(rows, index);
				this.parentCallBack._setEditorDirty(true);
			}
		}
	}
);
})();
