/**ManualExecProps******************************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");

//Dojo widget
dojo.require("dojox.data.dom");
dojo.require("dijit.form.Button");
dojo.require("dojo.parser");
dojo.require("jazz.ui.HoverPopup");

dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");

dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.defects.web.helper.RemoteItemPicker");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function() { // module container
var HoverPopup 						= jazz.ui.HoverPopup;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

var TeamServerClient 				= com.ibm.team.repository.web.transport.TeamServerClient;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;

var DOWNLOAD_SERVICE_URI 			= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var DEFECT_URL 						= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;
var AttachmentView					= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView;
var CommentView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView;
var CompareView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var getCurrentProjectArea           = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var NewDefectDataInitializer        = com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer;

var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;
var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var DeferredDialog					= com.ibm.rqm.defects.web.ui.view.common.DeferredDialog;
var ItemPickerUtil					= com.ibm.rqm.defects.web.util.ItemPickerUtil;

var RemoteItemPicker				= com.ibm.rqm.defects.web.helper.RemoteItemPicker;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;

var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_TYPE					= "keyword";
var Status                          = com.ibm.team.repository.web.foundation.Status;
var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties",[dijit._Widget, dijit._Templated],{
		ewi: null,
		script: null, 
		testcase: null,
		_steps: [],
		_currentStepNumber: 0,
		parentController: null,
		originalStepNum: null,
		//for Datapool: 
		_cells: [],
		keywordsWithoutVerdicts:[],
		defectTooltipMap: {},
		attachmentTooltipMap:{},
		tooltips:[],

		_showDefect:function(stepNum, propertyType){
			var defectProps = [];
			var props = this.stepProperties[stepNum];
			if(props){
				var len = props.length;
				for(var i=0;i<len ;i++)
					if(props[i].propertyType == propertyType)
						defectProps.push(props[i]);
			}
			this._defectIconClicked("show",defectProps,null);
		},
		
		_getEmptyRow: function(doc) {
			var row = doc.createElement("tr");
			row.className = "item-table-row";
			return row;
		},
		_getEmptyCell: function(doc,span, align) {
			var cell = doc.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			return cell;
		},
        	
		_createPropertiesHtml: function(doc,stepNum,properties,attachments,comment,compare){
			var attachCell = this._getEmptyCell(doc);
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
			var defectCell = this._getEmptyCell(doc);
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right";
			var commentCell = this._getEmptyCell(doc);
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right";
			var compareCell = this._getEmptyCell(doc);
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right";

			var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var attachmentsHtml = doc.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(doc.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(doc.createElement("tbody"));
			var commentsHtmlContent = doc.createElement("span");
			var defectsHtml = "";
			if(properties){
				var len = properties.length;
				var defectFound = false;
				for(var i=0;i<len;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
						if(defectFound == false){
							var defectImg = doc.createElement("img");
							defectImg.alt= Constants.getMessage("labelDefects");
							defectImg.src = ImageCache.DEFECT;
							defectImg.className = "type-image";
							defectImg.setAttribute("tabIndex", 0);
							defectImg.id = this.DEFECT_ICON + stepNum;
							defectCell.appendChild(defectImg);
								defectImg.onkeypress = this.connect(defectImg, "onkeypress", function(e){
									if(this.defectTooltipMap[stepNum])
										this.defectTooltipMap[stepNum].open();
								});
							defectFound = true;
						}							
						defectCount++;							
						if(properties[i].propertyType == DEFECT_VIEW_TYPE){
							var defectLabel = Constants.getMessage("labelDefectIdExecution",  properties[i].propertyValue);
							var anchorHTML = "<a href="+DEFECT_URL + properties[i].propertyValue+" target='_blank' tabindex='0'"+
												 "onclick='var e = event?event:window.event;e.stopPropagation?e.stopPropagation():(e.cancelBubble = true);'"+
												 ">"+defectLabel+"</a><br/>";
							defectsHtml+=anchorHTML;
						}else if (properties[i].propertyType == RTC_DEFECT_VIEW_TYPE){
							var defectLabel = properties[i].propertyName;
							var anchorHTML = "<a href="+properties[i].propertyValue+" target='_blank' tabindex='0'"+
											 "onclick='var e = event?event:window.event;e.stopPropagation?e.stopPropagation():(e.cancelBubble = true);'"+
											 ">"+defectLabel+"</a><br/>";
							defectsHtml+=anchorHTML;						}
						break;
					}
				}
			}
			if (attachments) {
				var attachLen = attachments.length;
				var attachmentFound = false;
				for (var i = 0; i < attachLen; i++) {
					if(attachmentFound == false){
						var attachImg = doc.createElement("img");
						attachImg.alt= Constants.getMessage("labelAttachment");
						attachImg.src = ImageCache.ATTACHMENT;
						attachImg.className = "type-image";
						attachImg.id = this.ATTACH_ICON + stepNum;	
						attachImg.setAttribute("tabIndex", 0);							
						attachCell.appendChild(attachImg);
						attachmentFound = true;
						dojox.data.dom.removeChildren(attachmentsHtmlContent);
						attachImg.onkeypress = this.connect(attachImg, "onkeypress", function(e){
							if(this.attachmentTooltipMap[stepNum])
								this.attachmentTooltipMap[stepNum].open();
							});
					}
					attachmentCount++;
					var attachmentsHtmlContentRow = this._getEmptyRow(doc);
					var attachmentsHtmlContentCell = this._getEmptyCell(doc);
					var attachmentsAnchor = doc.createElement("a");
					attachmentsAnchor.target = "_blank";
					attachmentsAnchor.appendChild(doc.createTextNode(attachments[i].name?attachments[i].name:attachments[i].fileName));
					attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + attachments[i].itemId?attachments[i].itemId:attachments[i].uuid;
					attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
					attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
					attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
				}
			}
			if(comment){
				commentFound = true;
				dojox.data.dom.removeChildren(commentsHtmlContent);
				commentsHtmlContent.appendChild(doc.createTextNode(comment));
				var commentImg = doc.createElement("img");
				commentImg.alt= Constants.getMessage("labelComment");
				commentImg.src = ImageCache.COMMENT;
				commentImg.className = "type-image";
				commentImg.id = this.COMMENT_ICON + stepNum;
				commentImg.setAttribute("tabIndex", 0);
				commentCell.appendChild(commentImg);
			}
			if(compare){
				var compareButton = doc.createElement("button");
				if(dojo.isIE >= 7)
						compareButton.style.backgroundColor = '#FFFFFF';
					else
						compareButton.style.background = "inherit";
				compareButton.style.border="0pt";
				var compareImg = doc.createElement("img");
				compareImg.alt= Constants.getMessage("labelCompare");
				compareImg.src = ImageCache.COMPARE;
				compareImg.className = "type-image";
				compareImg.setAttribute("tabIndex", 0);
				compareButton.id = this.COMPARE_ICON + stepNum;
				compareButton.appendChild(compareImg);
				compareCell.appendChild(compareButton);
				this.connect(compareButton, "onclick", dojo.hitch(this,"_showCompareDialog",stepNum,null));
			}
			if(attachmentCount>0){
				var _attachmentTooltipSpan = doc.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = doc.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				var tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
				this.tooltips.push(tooltip);
				if(this.attachmentTooltipMap[stepNum])
					this.attachmentTooltipMap[stepNum].destroy();
				this.attachmentTooltipMap[stepNum] = tooltip;
			}
			if(defectCount>0){
				var _defectTooltipSpan = doc.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = doc.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				var tooltip = new HoverPopup({
					around: [defectImg],
					html: defectsHtml
				});
				this.tooltips.push(tooltip);				
				if(this.defectTooltipMap[stepNum])
					this.defectTooltipMap[stepNum].destroy();
				this.defectTooltipMap[stepNum] = tooltip;				
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = doc.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				var tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);
				this.tooltips.push(tooltip);				
			}
			return [attachCell,defectCell,commentCell,compareCell];
		},
		_addNewDefectViaPicker: function(currentProvider){
			NewDefectDataInitializer.getDefectDescription(this.ewi, currentProvider, dojo.hitch(this, function(desc) {
				var self = this;
				var summary = this.ewi.name != this.ewi.testCase.name ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name) ;
	            // ... it's description ...
				// add build info if any
				if(this.parentEditor && this.parentEditor.result && this.parentEditor.result.buildRecord) {
	            	var buildRec = this.parentEditor.result.buildRecord;
	            	var buildInfo = (buildRec.parentBuildDefName) ? (buildRec.parentBuildDefName +  " : " + buildRec.name) : buildRec.name;
	            
	            	desc += "\r\n";
			        desc += Constants.getMessage("labelBuildRecord") + ":";
			        desc += "\r\n";
			    	desc += buildInfo;
			        desc += "\r\n";
	        	}
	            desc += Constants.getMessage("labelToProduce");
				var stepNum = this._currentStepNumber;
				var currentStep = 0;
				var steps = this._ER.elementResults;
	            for (var i = 0; i <= stepNum; i++) {
					// skip the keyword steps 
					if (steps[i].keywordStepType == 0 || steps[i].keywordStepType == 1) {
						var stepText = dojo.trim(unescape(steps[i].description));
						//remove all html tags
						stepText = stepText.replace(/<[^>]*?>/g, "");
						desc += (currentStep + 1) + ") " + stepText + "\r\n";
						currentStep++;
					}
	            }
	            
	            desc += Constants.getMessage("labelObserve");
		      	var creationUrl = null;
	            if (currentProvider.providerUris.defaultCreationDialogURI.indexOf("?") > -1) {
	               	creationUrl = currentProvider.providerUris.defaultCreationDialogURI + "&" + ItemPickerUtil.getWICreationDialogParamString(summary, desc);
	            } else {
					creationUrl = currentProvider.providerUris.defaultCreationDialogURI;	
				}
				var params= {
		            dialogTitle: Constants.getMessage("labelAddNewDefect"),
		            secondaryTitle: " ",
					pickerURL: creationUrl,
					height: currentProvider.providerUris.creationDialog.height,
					width: currentProvider.providerUris.creationDialog.width,
					parentElement: this.domNode,
					onOk: dojo.hitch(this, function(result) {
						console.debug(result);
						var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
						if (workItems.length > 0) {
							var workItem = workItems[0];
							var linkDescription = {
								url: workItem.url,
								linkComment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name),
								rqmUrl: this._getExecutionResultUri(),
								linkType: ChangeRequestManager.LINK_TYPE_AFFECT_ER
							};
							ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
								currentProvider.postLink(linkDescription, dojo.hitch(this, function(status){
									monitor.done();
									if (status.isOK()) {
										var callback = dojo.hitch(this, function(){
											this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(workItem));
											this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
										});
										
										this._postLinkToER(this._resultId, workItem, callback);
									}
									else 
										if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
											status.log();
											this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
										}
								}));
							}));
						}
					}),
					onClose: function() {
					    console.debug("close!");
					}
		
		        };	            
		        new RemoteItemPicker(params);
			}));
		},
		
		_addExistingDefectViaPicker: function(currentProvider){
			var self = this;
			
			var defectSelectionDialog = currentProvider.services.getSelectionDialog("defect", true);
			var params= {
	            dialogTitle: Constants.getMessage("labelAddExistingDefect"),
            	secondaryTitle: " ",
				pickerURL: defectSelectionDialog.uri,
				height: defectSelectionDialog.height,
				width: defectSelectionDialog.width,
				parentElement: this.domNode,
				onOk: dojo.hitch(this, function(result) {
					console.debug(result);
				
					var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
					if (workItems.length > 0) {
						var workItem = workItems[0];
						var linkDescription = {
							url: workItem.url,
							linkComment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name),
							rqmUrl: this._getExecutionResultUri(),
							linkType: ChangeRequestManager.LINK_TYPE_AFFECT_ER
						};
						ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
							currentProvider.postLink(linkDescription, dojo.hitch(this, function(status){
								monitor.done();
								if (status.isOK()) {
									var callback = dojo.hitch(this, function(){
										this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(workItem));
										this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
									});
									this._postLinkToER(this._resultId, workItem, callback);
								}
								else 
									if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
										status.log();
										this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
									}
							}));
						}));
					}
				}),
				onClose: function() {
				    console.debug("close!");
				}
	
	        };	            
	        new RemoteItemPicker(params);
		},
		
		_postLinkToTER: function(ewiItemId, workItem, callback){
			//Post local link to TER
			var postLinkToTER = dojo.hitch(this, function(monitor){
				var linkParams = {
					itemId: ewiItemId,
					cmUri: workItem.url,
					summary: workItem.summary,
					linkType: CmIntegrationClient.EWI_BLOCKING_DEFECT
				};
				CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
					monitor.done();
					callback();
                }));
			});
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
				postLinkToTER(monitor);
			}));
		},
		
		_postLinkToER: function(resultItemId, workItem, callback){
			var postLinkToER = dojo.hitch(this, function(monitor){
				var linkParams = {
					itemId: resultItemId,
					cmUri: workItem.url,
					summary: workItem.summary,
					linkType: CmIntegrationClient.RESULT_RELATEDTO_DEFECT
				};
				CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
					monitor.done();
					callback();
                }));
			});
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
				postLinkToER(monitor);
			}));
		},
		
		_getEwiUri: function() {
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + this.ewiItemId;
			return result;
		},
		
		
		_getExecutionResultUri:function(){
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionResult/" + this._resultId;
			return result;
		},

		_listAssociatedDefectsViaProvider: function() {
			var listDialog= AssociatedWorkItemViewer.create(this.ewiItemId, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, false);
		},
		
		_defectIconClicked: function(contextMenuSelection,properties,e){
			ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
	            if (currentProvider != null){
					this._dispatchDefectActionViaProvider(contextMenuSelection, properties, currentProvider);
				} else {
					this._defectIconClicked2(contextMenuSelection,properties,e);
				}
	        }));
		},
		
		_dispatchDefectActionViaProvider: function(contextMenuSelection,properties,currentProvider) {
			if (!contextMenuSelection || contextMenuSelection == "new") {
				if (this._resultId != null) 
					this._addNewDefectViaPicker(currentProvider);
				else {
					this.onApply(true, dojo.hitch(this, "_dispatchDefectActionViaProvider", contextMenuSelection, properties, currentProvider));
					this._toggleApplyButton(false);
				}
			} else if (contextMenuSelection == "existing") { 
				if (this._resultId != null) 
					this._addExistingDefectViaPicker(currentProvider);
				else {
					this.onApply(true, dojo.hitch(this, "_dispatchDefectActionViaProvider", contextMenuSelection, properties, currentProvider));
					this._toggleApplyButton(false);
				} 
			} else if (contextMenuSelection == "show") {
				this._showDefectViaProvier(properties)
			} else {
				this._listAssociatedDefectsViaProvider();
			}
		},
		
		_defectIconClicked2: function(contextMenuSelection,properties,e){
			    // specify the parent editor for the defectView to query related defects cached by the editor
			this._defectView = new DefectView({parentEditor: this.parentSection.parentEditor});
			if(!properties)	
				this._defectView.setData(this.propertiesMap[DEFECT_VIEW_TYPE].elements);
			else
				this._defectView.setData(properties);
			if(!contextMenuSelection)
				contextMenuSelection = "new";
			var dialogArgs = {
				primaryTitle: this.labelDefectsView,
	            isClosable: true,
				showActions:false,
				movable: true,
				style: "z-index: 100;",
				zIndex : 100
            };
			if (contextMenuSelection != "show") {
				dialogArgs.onClose = dojo.hitch(this, function(){
					this._checkAndupdateBlockingDefectList(this._defectView.isBlockingDefect(), this.propertiesMap[DEFECT_VIEW_TYPE].elements, this._convertProperties(this._defectView.getData()))
					this.propertiesMap[DEFECT_VIEW_TYPE].elements = this._convertProperties(this._defectView.getData());
					this._updateCurrentStepProps(DEFECT_VIEW_TYPE);
				});
                
                if(contextMenuSelection != "new")
				    this._defectView.setViewType(contextMenuSelection);
			}
			else
				this._defectView.setViewType("list");
                
            this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
			this._defectView.setParentDialog(this._defectsViewer);
			this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);            
            // this is a opening a new defect, get the initial seed values for the form.
            // Don't open the form until we've fetched all related data.
            if (contextMenuSelection == "new") {
               NewDefectDataInitializer.getDefectSeedValuesFromEWI(this.ewi, dojo.hitch(this, "_initNewDefectForm"));
			   var cshelp = new CSHelp({contextID: "rqm_add_new_def.html"});
				cshelp.setButtonLabel(Constants.getMessage("labelAddNewDefectHelp"));
				this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
            }
            else {
				if (contextMenuSelection == "existing") {
					var cshelp = new CSHelp({contextID: "rqm_add_exist_def.html"});
					cshelp.setButtonLabel(Constants.getMessage("labelAddExistingDefectHelp"));
					this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
				}
                this._defectsViewer.open();
                this._defectsViewer.setWidth('800px');
            }
		},

        _initNewDefectForm: function(seedValues) {
            // add in additional details.
            if (this._currentStepNumber >= 0 && this._currentStepNumber < this._ER.elementResults.length) {
                var stepText = dojo.trim(unescape(this._ER.elementResults[this._currentStepNumber].description));
				//remove all html tags
				stepText = stepText.replace(/<[^>]*?>/g, "");
                if(stepText.length > 128)
                    stepText = stepText.substr(0, 125) + "...";

                seedValues[NewDefectDataInitializer.FAILED_VER_POINT_ATTR] = stepText;
            }
            this._defectView.setViewType("new", seedValues);    
            this._defectsViewer.open();
            this._defectsViewer.setWidth('800px');
        },
        
		_commentIconClicked: function(e){
			var dialogArgs = {
			primaryTitle: this.labelCommentsView,
            isClosable: true,
			okCallback: dojo.hitch(this, function(){
				var comment = this._commentView.getData(true);
				var commentArea = document.getElementById(this.ID_COMMENT_COL_AREA + this._currentStepNumber);
				if(commentArea)
					commentArea.value = comment;
				this.comment = comment;
				this._updateCurrentStepProps(COMMENT_VIEW_TYPE);
				}),
			cancelCallback: dojo.hitch(this, function(){
				this._comment.focus();
				})
            };                
            this._commentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
            this._commentsViewer.setWidth('600px');
			this._commentView = new CommentView();
			this._commentView.setData(this.comment,true);
			this._commentsViewer.contentContainer.appendChild(this._commentView.domNode);			
			this._commentsViewer.open();
		},
		
		_checkAndupdateBlockingDefectList: function(isBlocking, oldList, newList){
			if(isBlocking && oldList.length != newList.length){
				var blockingDefectList = newList;
				var len = newList.length;
				var len2 = oldList.length;
				for(var i=0;i<len;i++){
					for(var j=0;j<len2;j++){
						if(newList[i].propertyValue == oldList[j].propertyValue){
							var len3 = blockingDefectList.length;
							for(var k=0;k<len3;k++){
								if(blockingDefectList[k].propertyValue == newList[i].propertyValue){
									blockingDefectList.splice(k,1)
									break;
								}
							}
						}
					}
				}
				var blockingDefectId = blockingDefectList.length > 0 ? blockingDefectList[0].propertyValue : null;
				console.debug("Blocking Defect found - "+blockingDefectId);
				if(blockingDefectId){
					var manuSelf =this;
				    var callbackObj ={
					    success: function(ewi){
					  		manuSelf.ewi = ewi;
					  	},
					  	failure: function(error){
					  		console.error("could not updateEWI with blocking defect "+blockingDefectId +"Error code "+error.message);
					  	}
					}
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");			
					ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, {id: this.ewi.id, ewiStateId:this.ewi.stateId,addDefectIds: [blockingDefectId]});
				}
			}
		},
		_attachmentIconClicked: function(e){             
			if(this._resultAttachmentView)
				this._resultAttachmentView.destroyRecursive();
			this._resultAttachmentView = new AttachmentView();
			this._resultAttachmentView.setData(this.attachments,this.removedAttachments,true);
			
			var dialogArgs = {
				primaryTitle: this.labelAttachmentsView,
	            isClosable: true,
				okCallback: dojo.hitch(this, function(){
					this.removedAttachments = this._resultAttachmentView.getRemovedAttachments();
					this.attachments = this._resultAttachmentView.getData(RESULT_ATTACTMENT_VIEW_TYPE,true);
					this._updateCurrentStepProps(ATTACHMENT_VIEW_TYPE);
				}),
				cancelCallback: dojo.hitch(this, function(){
					this._attachment.focus();
				})
            };			
			this._attachmentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
			this._attachmentsViewer.contentContainer.appendChild(this._resultAttachmentView.domNode);
			this._attachmentsViewer.open();
			//somehow the width doesnt get set correctly unless done after open
			this._attachmentsViewer.setWidth('600px');
		},
		
        ////////////////////////////////
		// Properties related stuff
		////////////////////////////////
        _showCompareDialog:function(stepNum,compareText){
			var stepCompare = compareText ? compareText:this._ER.elementResults[stepNum].compare;
			if(!stepCompare)
				return;
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			this.compareView = new CompareView({
				hideActual: false,
				callback: dojo.hitch(this, "_closePopup"),
				callbackData: stepNum
			});
			dojo.style(this.compareView.domNode,"background","white");
			dojo.style(this.compareView.domNode,"border","1px solid gray");
			dojo.style(this.compareView.domNode,"padding","5px");
			dojo.style(this.compareView.domNode,"width","200px");
			this.compareView.setData(stepCompare,true);
			var self = this;
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onClose: function(){
					dojo._destroyElement(self.compareView.domNode);
				}
			});
			this.compareView.setFocus();
		},
		_closePopup:function(stepNum){
			var compare = this.compareView.getData(true);
			this._ER.elementResults[stepNum].compare = compare;
			this.uncommittedProperty[stepNum] = true;
			if (stepNum == this._currentStepNumber) {
				this.compare = compare;
				this._updateCurrentStepProps();
			}
			if (this.compareView) {
				dijit.popup.close(this.compareView);
				this.compareView.destroyRecursive();
				this.compareView = null;
			}
		},
		updateCommentProperty:function(comment,stepNum){
			this._ER.elementResults[stepNum].comment = comment;
			this.uncommittedProperty[stepNum] = true;
			var doc = document;
			var commentCurr = dojo.byId(this.COMMENT_ID  + stepNum,doc);
			var propshtml = this._createPropertiesHtml(doc,stepNum,null,null,comment,null);
			if(commentCurr)
				commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);
		},
		/*
		 * Called when any dialog is closed from the UI
		 * this.propertiesMap contains the current step only.
		 * After callback success, focus back to property button
		 */
		_updateCurrentStepProps:function(callbackType){
			this.uncommittedProperty[this._currentStepNumber] = true;
			var properties = [];
			for(var propertyType in this.propertiesMap)
				properties = properties.concat(this.propertiesMap[propertyType].elements);
			var elementResult = this._ER.elementResults[this._currentStepNumber]; 
			elementResult.properties = properties;
			elementResult.attachments = this.attachments;
			elementResult.removedAttachments = this.removedAttachments;
			elementResult.comment = this.comment;
			elementResult.compare = this.compare;
			var doc = document;
			var attachCurr = dojo.byId(this.ATTACH_ID  + this._currentStepNumber,doc);
			var defectCurr = dojo.byId(this.DEFECT_ID  + this._currentStepNumber,doc);
			var commentCurr = dojo.byId(this.COMMENT_ID  + this._currentStepNumber,doc);
			var compareCurr = dojo.byId(this.COMPARE_ID  + this._currentStepNumber,doc);
			var propshtml = this._createPropertiesHtml(doc,this._currentStepNumber,properties,this.attachments,this.comment,this.compare);
			if(attachCurr)
				attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
			if(defectCurr)
				defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
			if(commentCurr)
				commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);
			if(this.originalStepNum != null)
                this._staleStepUpdated = true;
			if(callbackType) {
				switch(callbackType){
					case DEFECT_VIEW_TYPE:
					case RTC_DEFECT_VIEW_TYPE:
						this._defect.focus();
						break;
					case ATTACHMENT_VIEW_TYPE:
					case RESULT_ATTACTMENT_VIEW_TYPE:
						this._attachment.focus();
						break;
					case COMMENT_VIEW_TYPE:
						this._comment.focus();
						break;
					case COMPARE_VIEW_TYPE:
					default:
						//do Nothing
				}
			}
		},

		setProperties: function(resultElement){
			if(!this.propertiesMap)
				this.propertiesMap = [];
			if(!resultElement)
				return;
			var propertiesMap = this.propertiesMap;
			var properties = resultElement.properties;
			this.attachments = resultElement.attachments;
			this.comment = resultElement.comment;
			this.compare = resultElement.compare;
			propertiesMap[DEFECT_VIEW_TYPE] = {elements:[]};
			propertiesMap[RTC_DEFECT_VIEW_TYPE] = {elements:[]};
			propertiesMap[KEYWORD_TYPE] = {elements:[]};
			this.removedAttachments = resultElement.removedAttachments;
			if(properties){
				var len = properties.length;
				for (var i = 0; i < len; i++) {
					if(!propertiesMap[properties[i].propertyType])
						propertiesMap[properties[i].propertyType] = {elements:[]};
					propertiesMap[properties[i].propertyType].elements.push(properties[i]);
				}
			}
			if(this.compare)
				this._showCompareDialog(this._currentStepNumber,this.compare);
		},
		
		_convertProperties:function(properties){
			var elements = [];
			if(properties){
				var len = properties.length;
				for(var i=0;i<len;i=i+3 ){
					var property = {
						propertyType: properties[i],
						propertyName: properties[i+1],
						propertyValue: properties[i+2]
					}
					if(property.propertyValue != null && property.propertyValue.length>0)
						elements.push(property);
				}
			}
			return elements;
		},

		getProperties:function(){
			var stepProps = [];
			for(var propertyType in this.propertiesMap)
				stepProps = stepProps.concat(this.propertiesMap[propertyType].elements);
            return stepProps;
		},
		
		_convertPropertiesViaProvider: function(draftLinkParams) {
			var property = {
				propertyType: RTC_DEFECT_VIEW_TYPE,
				propertyName: draftLinkParams.summary,
				propertyValue: draftLinkParams.url
			}
			return property; 
		},
		
		_showDefectViaProvier: function(properties) {
			var draftUriFilter = [];
			var len = properties.length;
			for(var i = 0; i < len; i++){
				draftUriFilter.push(properties[i].propertyValue);
			}
			var listDialog= AssociatedWorkItemViewer.create(this.ewiItemId, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, false, draftUriFilter);
		},
		_toggleCommentsColumn:function(){
			var doc = document;
			var numberOfSteps = this.numberOfSteps;
			var _currentIterNumber = this._currentIterNumber;
			var start = numberOfSteps*_currentIterNumber;
			var end = start+numberOfSteps;
			this.showCommentsCol = !this.showCommentsCol;
			var ID_COMMENT_COL_CELL = this.ID_COMMENT_COL_CELL;
			var COMMENT_ID = this.COMMENT_ID;
			if (this.showCommentsCol) {
				dojo.style(this.comments_col_header, 'display', '');
				dojo.style(this.comments_col, 'display', '');
				for(var i=start;i<end;i++){
					var commentAreaCell = doc.getElementById(ID_COMMENT_COL_CELL+i);
					if(commentAreaCell)
						dojo.style(commentAreaCell,'display','');
					var commentCell = doc.getElementById(COMMENT_ID+i);
					if(commentCell)
						dojo.style(commentCell,'display','none');
				}
			}else{
				dojo.style(this.comments_col_header, 'display', 'none');
				for(var i=start;i<end;i++){
					var commentAreaCell = doc.getElementById(ID_COMMENT_COL_CELL+i);
					if(commentAreaCell)
						dojo.style(commentAreaCell,'display','none');
					var commentCell = doc.getElementById(COMMENT_ID+i);
					if(commentCell)
						dojo.style(commentCell,'display','');
						
				}
				dojo.style(this.comments_col, 'display', 'none');
			}
		},
		_buildDefectIdList: function(properties){
            var defectIdList = [];
            if (properties) {
				var len = properties.length;
                for (var i = 0; i < len; i++) {
                    if (properties[i].propertyType == DEFECT_VIEW_TYPE) 
                        defectIdList.push(properties[i].propertyValue);
                }
            }
            return defectIdList;
		},
        
		_buildAttachmentIdList: function(attachments,onlyNew){
            var attachmentIdList = [];
			if(attachments){
				var len = attachments.length;
				for(var i=0;i<len;i++){
					if(onlyNew && attachments[i].isNew)
                    	attachmentIdList.push(attachments[i].uuid);
					else if(!onlyNew)
						attachmentIdList.push(attachments[i].uuid);
				}
	        }
            return attachmentIdList;
		},
		_displayAlertDialog: function(message){
            var args = {
				message: message
			}
			var alertDialog = new AlertDialog( args );
            alertDialog.open();
        },
		uninitialize: function(){
			dojo.forEach(this.tooltips, function(tooltip){
				if (tooltip.destroyRecursive) {
					tooltip.destroyRecursive();
				}
			});
			this.tooltips = [];
		}
});
})();	
